Search results

GanttModel API in JavaScript (ES5) Gantt API control

Interface for a class Gantt

Properties

actionBegin

EmitType<``Object|PageEventArgs|FilterEventArgs|SortEventArgs|ITimeSpanEventArgs|IDependencyEventArgs|ITaskAddedEventArgs|ZoomEventArgs>

Triggers when Gantt actions such as sorting, filtering, searching etc., starts.

actionComplete

EmitType<``FilterEventArgs|SortEventArgs|ITaskAddedEventArgs|IKeyPressedEventArgs|ZoomEventArgs>

Triggers when Gantt actions such as sorting, filtering, searching etc. are completed.

actionFailure

EmitType<FailureEventArgs>

Triggers when actions are failed.

beforeExcelExport

EmitType<Object>

Triggers before Gantt data is exported to Excel file.

beforePdfExport

EmitType<Object>

Triggers before Gantt data is exported to PDF document.

beforeTooltipRender

EmitType<BeforeTooltipRenderEventArgs>

Triggers before tooltip get rendered.

cellDeselected

EmitType<CellDeselectEventArgs>

Triggers when a particular selected cell is deselected.

cellDeselecting

EmitType<CellDeselectEventArgs>

Triggers before the selected cell is deselecting.

cellEdit

EmitType<CellEditArgs>

This will be triggered a cell get begins to edit.

cellSelected

EmitType<CellSelectEventArgs>

Triggers after a cell is selected.

cellSelecting

EmitType<CellSelectingEventArgs>

Triggers before any cell selection occurs.

collapsed

EmitType<ICollapsingEventArgs>

This will be triggered after the row getting collapsed.

collapsing

EmitType<ICollapsingEventArgs>

This will be triggered before the row getting collapsed.

columnDrag

EmitType<ColumnDragEventArgs>

Triggers when column header element is dragged (moved) continuously.

columnDragStart

EmitType<ColumnDragEventArgs>

Triggers when column header element drag (move) starts.

columnDrop

EmitType<ColumnDragEventArgs>

Triggers when a column header element is dropped on the target column.

columnMenuClick

EmitType<ColumnMenuClickEventArgs>

Triggers when click on column menu.

columnMenuOpen

EmitType<ColumnMenuOpenEventArgs>

Triggers before column menu opens.

contextMenuClick

EmitType<CMenuClickEventArgs>

Triggers when click on context menu.

contextMenuOpen

EmitType<CMenuOpenEventArgs>

Triggers before context menu opens.

created

EmitType<Object>

Triggers when the component is created.

dataBound

EmitType<Object>

Triggers when data source is populated in the Grid.

dataStateChange

EmitType<DataStateChangeEventArgs>

Triggers when the Gantt actions such as Sorting, Editing etc., are done. In this event,the current view data and total record count should be assigned to the dataSource based on the action performed.

destroyed

EmitType<Object>

Triggers when the component is destroyed.

endEdit

EmitType<ITaskbarEditedEventArgs>

This will be triggered when a task get saved by cell edit.

excelExportComplete

EmitType<ExcelExportCompleteArgs>

Triggers after Gantt data is exported to Excel file.

excelHeaderQueryCellInfo

EmitType<ExcelHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to Excel file. You can also customize the Excel cells.

excelQueryCellInfo

EmitType<ExcelQueryCellInfoEventArgs>

Triggers before exporting each cell to Excel file. You can also customize the Excel cells.

expanded

EmitType<ICollapsingEventArgs>

This will be triggered after the row getting expanded.

expanding

EmitType<ICollapsingEventArgs>

This will be triggered before the row getting expanded.

headerCellInfo

EmitType<HeaderCellInfoEventArgs>

This will be triggered before the header cell element is appended to the Grid element.

load

EmitType<Object>

Triggered before the Gantt control gets rendered.

onMouseMove

EmitType<IMouseMoveEventArgs>

This event will be triggered when mouse move on Gantt.

onTaskbarClick

EmitType<ITaskbarClickEventArgs>

This event will be triggered when click on taskbar element.

pdfColumnHeaderQueryCellInfo

EmitType<PdfColumnHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to PDF document. You can also customize the PDF cells.

pdfExportComplete

EmitType<Object>

Triggers after TreeGrid data is exported to PDF document.

pdfQueryCellInfo

EmitType<PdfQueryCellInfoEventArgs>

Triggers before exporting each cell to PDF document. You can also customize the PDF cells.

pdfQueryTaskbarInfo

EmitType<Object>

Triggers before exporting each taskbar to PDF document. You can also customize the taskbar.

pdfQueryTimelineCellInfo

EmitType<PdfQueryTimelineCellInfoEventArgs>

Triggers before exporting each cell to PDF document. You can also customize the PDF cells.

queryCellInfo

EmitType<QueryCellInfoEventArgs>

This will be triggered before the header cell element is appended to the Grid element.

queryTaskbarInfo

EmitType<IQueryTaskbarInfoEventArgs>

This will be triggered after the taskbar element is appended to the Gantt element.

recordDoubleClick

EmitType<RecordDoubleClickEventArgs>

This event will be triggered when double click on record.

resizeStart

EmitType<ResizeArgs>

Triggers when column resize starts.

resizeStop

EmitType<ResizeArgs>

Triggers when column resize ends.

resizing

EmitType<ResizeArgs>

Triggers on column resizing.

rowDataBound

EmitType<RowDataBoundEventArgs>

This will be triggered before the row element is appended to the Grid element.

rowDeselected

EmitType<RowDeselectEventArgs>

Triggers when a selected row is deselected.

rowDeselecting

EmitType<RowDeselectEventArgs>

Triggers before deselecting the selected row.

rowDrag

EmitType<RowDragEventArgs>

Triggers when row elements are dragged (moved) continuously.

rowDragStart

EmitType<RowDragEventArgs>

Triggers when row element’s drag(move) starts.

rowDragStartHelper

EmitType<RowDragEventArgs>

Triggers when row element’s before drag(move).

rowDrop

EmitType<RowDragEventArgs>

Triggers when row elements are dropped on the target row.

rowSelected

EmitType<RowSelectEventArgs>

Triggers after row selection occurs.

rowSelecting

EmitType<RowSelectingEventArgs>

Triggers before row selection occurs.

splitterResizeStart

EmitType<ResizeEventArgs>

Triggers when splitter resizing starts.

splitterResized

EmitType<ISplitterResizedEventArgs>

Triggers when splitter resizing action completed.

splitterResizing

EmitType<ResizingEventArgs>

Triggers when splitter bar was dragging.

taskbarEdited

EmitType<ITaskbarEditedEventArgs>

Triggered when a taskbar is dragged and dropped into a new position on the Gantt chart.

taskbarEditing

EmitType<ITaskbarEditedEventArgs>

Triggered when a taskbar is in the dragging state on the Gantt chart.

toolbarClick

EmitType<ClickEventArgs>

Triggers when toolbar item was clicked.

UpdateOffsetOnTaskbarEdit

boolean

Specifies whether to update offset value on a task for all the predecessor edit actions.

addDialogFields

AddDialogFieldSettingsModel[]

Defines the tabs and fields to be displayed in the add dialog. If not specified, the fields will be derived from the taskSettings and columns values.

    <div id="Gantt"></div>
    import { Gantt } from '@syncfusion/ej2-gantt';
    let gantt: Gantt = new Gantt({
        addDialogFields: [
            { type: 'General', headerText: 'General', fields: ['TaskID', 'TaskName'] },
            { type: 'Resources' },
            { type: 'Dependency' },
            { type: 'Notes'}
        ],
    });
    gantt.appendTo('#Gantt');

allowExcelExport

boolean

If allowExcelExport set to true, then it will allow the user to export Gantt chart to Excel and CSV file.

allowFiltering

boolean

Enables or disables filtering functionality in the Gantt chart.

allowKeyboard

boolean

Enables or disables keyboard interactions in the Gantt chart.

allowParentDependency

boolean

Specifies whether to allow dependency connection support for parent records.

allowPdfExport

boolean

If allowPdfExport set to true, then it will allow the user to export Gantt chart to PDF file.

allowReordering

boolean

If allowReordering is set to true, Gantt chart columns can be reordered. Reordering can be done by drag and drop of a particular column from one index to another index.

allowResizing

boolean

Enables column resizing in the Gantt chart when allowResizing is set to true. When enabled, users can adjust the width of columns by dragging the column borders.

allowRowDragAndDrop

boolean

If allowRowDragAndDrop set to true, then it will allow the user to perform row drag and drop action in Gantt chart.

allowSelection

boolean

If allowSelection is set to true, it enables row selection in the Gantt chart, and the selected rows are highlighted.

allowSorting

boolean

If allowSorting is set to true, it enables sorting of Gantt chart tasks when the column header is clicked.

allowTaskbarDragAndDrop

boolean

Defines whether to enable or disable the taskbar drag and drop action in the Gantt chart.

allowTaskbarOverlap

boolean

Specifies whether taskbars can overlap in the Gantt chart.

allowUnscheduledTasks

boolean

Enables or disables the rendering of unscheduled tasks in the Gantt chart. When allowUnscheduledTasks set to true, unscheduled tasks will be displayed in the chart.

autoCalculateDateScheduling

boolean

Specifies whether to auto calculate the start and end dates based on factors such as working time, holidays, weekends, and task dependencies.

autoFocusTasks

boolean

Enables or disables automatic focusing on the taskbar when a task is clicked.

baselineColor

string

Specifies the color of the baseline bar in the Gantt chart.

collapseAllParentTasks

boolean

Defines whether all root tasks should be rendered in a collapsed state. When collapseAllParentTasks set to true, all parent tasks will be collapsed by default.

columnMenuItems

[]

columnMenuItems defines both built-in and custom menu items for the Gantt chart column menu.

The available built-in items are,

  • ColumnChooser - To show/hide the TreeGrid columns.
  • SortAscending - Sort the current column in ascending order.
  • SortDescending - Sort the current column in descending order.
  • AutoFitAll - Auto fit the size of all columns.
  • AutoFit - Auto fit the size of the current column.
  • Filter - Displays filter options based on the filterSettings property.

columns

Column[] | string[] | ColumnModel[]

Defines the collection of columns displayed in the Gantt chart grid. If the columns declaration is empty, the columns are automatically populated based on the taskSettings values.

    <div id="Gantt"></div>
    import { Gantt } from '@syncfusion/ej2-gantt';
    let gantt: Gantt = new Gantt({
        columns: [
            { field: 'TaskID', width: '150', headerText: 'Task ID', headerTextAlign: 'Left' allowFiltering: false },
            { field: 'TaskName', clipMode: 'EllipsisWithTooltip' allowEditing: true, hideAtMedia: '(min-width: 700px)' },
            { field: 'Duration', edittype: 'stringedit', allowReordering: true, maxWidth: '400' },
            { field: 'Progress', textAlign: 'Right', allowResizing: false , visible: true, format: 'C' },
            { field: 'StartDate', width: '250', allowSorting: false, minWidth: '200' }
        ]
    });
    gantt.appendTo('#Gantt');

connectorLineBackground

string

Defines the background color of the dependency lines (connector lines) in the Gantt chart. You can set the color as a valid CSS color string (e.g., “red”, “#FF5733”, “rgb(255,0,0)”).

connectorLineWidth

number

Defines the width of the dependency lines in the Gantt chart. The value should be a positive integer, representing the thickness of the lines.

contextMenuItems

ContextMenuItem[] | ContextMenuItemModel[]

Defines the built-in and custom items that appear in the context menu of the Gantt chart. You can use this property to control the content and functionality of the right-click context menu.

    <div id="Gantt"></div>
    import { Gantt } from '@syncfusion/ej2-gantt';
    import { ContextMenuItemModel } from '@syncfusion/ej2-grids';
    Gantt.Inject(ContextMenu);
    let contextMenuItems: (string | ContextMenuItemModel)[] = ['AutoFitAll', 'AutoFit', 'TaskInformation', 'DeleteTask', 'Save', 'Cancel', 'SortAscending', 'SortDescending', 'Add', 'DeleteDependency', 'Convert',
        { text: 'Collapse the Row', target: '.e-content', id: 'collapserow' } as ContextMenuItemModel,
        { text: 'Expand the Row', target: '.e-content', id: 'expandrow' } as ContextMenuItemModel,
    ];
    let gantt: Gantt = new Gantt({
        contextMenuItems: contextMenuItems as ContextMenuItem[],
    });
    gantt.appendTo('#Gantt');

dataSource

Object[] | DataManager | Object

Defines the data source for the Gantt chart, which is used to render rows and tasks. The dataSource can be an array of JavaScript objects, an instance of DataManager, or a single object. The array of objects should contain the task data with properties such as TaskID, TaskName, StartDate, EndDate, etc. This allows dynamic binding of tasks and their relationships (e.g., dependencies, subtasks, progress) to the Gantt chart.

    <div id="Gantt"></div>
    import { Gantt } from '@syncfusion/ej2-gantt';
    let gantt: Gantt = new Gantt({
        // Hierarchical data binding.
        dataSource: [{
            TaskID: 1,
            TaskName: 'Project Initiation',
            StartDate: new Date('04/02/2019'),
            EndDate: new Date('04/21/2019'),
            subtasks: [
                { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
            ]
        },]
        // Self-referential data binding (Flat data).
        dataSource:  [
            { TaskID: 1,TaskName: 'Project Initiation',StartDate: new Date('04/02/2019'),EndDate: new Date('04/21/2019')},
            { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50,ParentId:1 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50, ParentId:1   },
        ];
        // Remote Data    
        dataSource: dataSource,
    });
    // Remote Data
    let dataSource: DataManager = new DataManager({
        url: 'https://ej2services.syncfusion.com/production/web-services/api/GanttData',
        adaptor: new WebApiAdaptor,
        crossDomain: true
    });
    gantt.appendTo('#Gantt');

dateFormat

string

Specifies the date format for displaying dates in the Gantt chart, including in tooltips and grid cells. By default, the format is determined based on the current culture/locale settings.

dayWorkingTime

DayWorkingTimeModel[]

Defines the customized working time for the project. This helps in accurately planning tasks based on available working hours and ensures proper task scheduling.

    <div id="Gantt"></div>
    import { Gantt } from '@syncfusion/ej2-gantt';
    let gantt: Gantt = new Gantt({
        dayWorkingTime: [from: 9 to: 18]
    });
    
    gantt.appendTo('#Gantt');

disableHtmlEncode

boolean

If disableHtmlEncode is set to true, the Gantt component disables HTML entity encoding across the Gantt content, allowing custom HTML elements to be rendered.

durationUnit

DurationUnit

durationUnit Specifies the duration unit for each task. The available options are:

  • day: Sets the duration unit to day.
  • hour: Sets the duration unit to hour.
  • minute: Sets the duration unit to minute.

editDialogFields

EditDialogFieldSettingsModel[]

Defines the tabs and fields to be displayed in the edit dialog. If not specified, the fields will be derived from the taskSettings and columns values.

    <div id="Gantt"></div>
    import { Gantt } from '@syncfusion/ej2-gantt';
    let gantt: Gantt = new Gantt({
        editDialogFields: [
            { type: 'General', headerText: 'General', fields: ['TaskID', 'TaskName'] },
            { type: 'Resources' },
            { type: 'Dependency' },
            { type: 'Notes'}
        ],
    });
    gantt.appendTo('#Gantt');

editSettings

EditSettingsModel

Configures the edit settings for the Gantt chart, such as enabling or disabling task modifications.

    <div id="Gantt"></div>
    import { Gantt, Edit  } from '@syncfusion/ej2-gantt';
    Gantt.Inject(Edit);
    let gantt: Gantt = new Gantt({
        editSettings: {
            allowAdding: true,
            allowEditing: true,
            allowDeleting: true,
            allowTaskbarEditing: true,
            mode:'Auto',
            newRowPosition: 'Top',
            showDeleteConfirmDialog: true
        }
    });
    gantt.appendTo('#Gantt');

enableAdaptiveUI

boolean

If enableAdaptiveUI is set to true, the pop-up UI becomes adaptive to smaller screens, enabling better usability for filtering and other features.

enableContextMenu

boolean

If enableContextMenu is set to true, enables the context menu in the Gantt chart. The context menu provides additional actions that can be accessed by right-clicking on Gantt chart elements

enableCriticalPath

boolean

Enables the highlighting of critical tasks in the Gantt Chart that directly affect the project’s end date. When enabled, tasks that are critical to the project timeline will be visually distinguished by colours.

enableHtmlSanitizer

boolean

Specifies whether to display or remove the untrusted HTML values in the TreeGrid component. If enableHtmlSanitizer set to true, any potentially harmful strings and scripts are sanitized before rendering.

enableImmutableMode

boolean

If enableImmutableMode is set to true, the Gantt Chart will reuse existing rows from previous results instead of performing a full refresh when Gantt actions are executed.

enableMultiTaskbar

boolean

Enables the rendering of child taskbars on the parent row when it is in a collapsed state in the Gantt chart.

enablePersistence

boolean

Enable or disable persisting component’s state between page reloads.

enablePredecessorValidation

boolean

If enablePredecessorValidation is set to true, enables validation for predecessor links in the Gantt chart.

enableRtl

boolean

Enable or disable rendering component in right to left direction.

enableTimelineVirtualization

boolean

Enables better performance for projects with a large time span by initially rendering only the visible timeline cells. Subsequent cells are loaded on horizontal scrolling.

enableUndoRedo

boolean

Enables or disables the undo and redo functionality in the Gantt chart.

enableVirtualMaskRow

boolean

Specifies whether to display shimmer effect during scrolling action in virtual scrolling feature. If disabled, spinner is shown instead of shimmer effect.

enableVirtualization

boolean

If enableVirtualization is set to true, the Gantt chart will render only the rows visible within the viewport. and load subsequent rows as the user scrolls vertically. This improves performance when dealing with large datasets.

eventMarkers

EventMarkerModel[]

Defines the events and milestones along the project timeline. These event markers indicate significant events or milestones throughout the project’s duration.

    <div id="Gantt"></div>
    import { Gantt, DayMarkers } from '@syncfusion/ej2-gantt';
    Gantt.Inject(DayMarkers);
    let gantt: Gantt = new Gantt({
        eventMarkers: [
        {
            day: '04/10/2019',
            cssClass: 'e-custom-event-marker',
            label: 'Project approval and kick-off'
        }
    ]
    });
    gantt.appendTo('#Gantt');

filterSettings

FilterSettingsModel

Configures the filter settings for the Gantt chart, enabling users to filter tasks based on specific columns or criteria. The filterSettings property allows customization of filter behavior, such as which columns to filter and the filter type.

    <div id="Gantt"></div>
    import { Gantt, Filter } from '@syncfusion/ej2-gantt';
    Gantt.Inject(Filter);
    let gantt: Gantt = new Gantt({
        filterSettings: {
            columns: [{ field: 'TaskName', matchCase: false, operator: 'startswith', predicate: 'and', value: 'Identify' },{ field: 'TaskID', matchCase: false, operator: 'equal', predicate: 'and', value: 2 }],
            ignoreAccent: true
        },
    ]
    });
    gantt.appendTo('#Gantt');

gridLines

GridLine

Configures the grid lines displayed in the TreeGrid and Gantt chart. The gridLines property allows customization of the type of grid lines to be shown, either horizontal, vertical, or both.

height

number | string

Defines the height of the Gantt component container. The height property can be set to a specific value (in pixels or percentage) or set to ‘auto’ for automatic height adjustment based on content.

highlightWeekends

boolean

If highlightWeekends is set to true, it highlights all weekend days in the week-day timeline mode. This makes weekends visually distinct in the timeline view.

holidays

HolidayModel[]

Defines holidays within the project timeline, allowing you to mark specific dates as holidays. This helps in accounting for non-working days in scheduling and task planning.

    <div id="Gantt"></div>
    import { Gantt, DayMarkers } from '@syncfusion/ej2-gantt';
    Gantt.Inject(DayMarkers);
    let gantt: Gantt = new Gantt({
        holidays: [{
            from: "04/04/2019",
            to: "04/05/2019",
            label: "Public holidays",
            cssClass: "e-custom-holiday"
        }]
    });
    gantt.appendTo('#Gantt');

includeWeekend

boolean

Defines whether weekend days should be considered as working days in the Gantt chart. When includeWeekend set to true, weekends (Saturday and Sunday) are treated as regular working days.

labelSettings

LabelSettingsModel

Configures the labels displayed on the right, left, and inside the taskbars in the Gantt chart.

    <div id="Gantt"></div>
    import { Gantt } from '@syncfusion/ej2-gantt';
    let gantt: Gantt = new Gantt({
        labelSettings: {
            leftLabel: 'TaskID',
            rightLabel: 'Task Name: ${taskData.TaskName}',
            taskLabel: '${Progress}%'
        }
    });
    gantt.appendTo('#Gantt');

loadChildOnDemand

boolean

Gets or sets whether to load child records on demand in remote data binding. When loadChildOnDemand set to true, child records are loaded only when expanded, and parent records are rendered in a collapsed state initially.

loadingIndicator

LoadingIndicatorModel

Configures the loading indicator for the Gantt Chart. Specifies the type of indicator to display (spinner or shimmer effect) during waiting periods when actions are performed in the Gantt Chart.

locale

string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

milestoneTemplate

string | Function

Defines a custom template for rendering milestone tasks in the Gantt chart. This template allows you to customize the appearance of milestone tasks.

parentTaskbarTemplate

string | Function

Defines a custom template for rendering parent task bars in the Gantt chart. This template allows you to customize the appearance of parent task bars.

<script type="text/x-jsrender" id="ParentTaskbarTemplate">
   <div class="e-gantt-parent-taskbar-inner-div e-gantt-parent-taskbar" style="height:100%">
      <div class="e-gantt-parent-progressbar-inner-div e-gantt-parent-progressbar" style="width:${ganttProperties.progressWidth}px;height:100%">
      <span class="e-task-label" style="position: absolute; z-index: 1; font-size: 12px; color: white; top: 5px; left: 10px; font-family: "Segoe UI"; overflow: hidden; text-overflow: ellipsis; width: 40%; cursor: move;">${taskData.TaskName}</span>
   </div>
   </div>
</script>
    import { Gantt } from '@syncfusion/ej2-gantt';
    let gantt: Gantt = new Gantt({       
    parentTaskbarTemplate: '#ParentTaskbarTemplate',
    });
    gantt.appendTo('#Gantt');

projectEndDate

Date | string

Defines the end date of the project. If the projectEndDate is not set, it will be automatically calculated based on the data source. The date can be provided as a Date object or a string in a valid date format.

projectStartDate

Date | string

Defines the start date of the project. If the projectStartDate is not set, it will be automatically calculated based on the data source. The date can be provided as a Date object or a string in a valid date format.

query

Query

Defines an external Query that will be executed in conjunction with data processing to filter, sort the data. This allows for advanced data manipulation before binding the data to the Gantt chart.

readOnly

boolean

If readOnly is set to true, the Gantt chart becomes read-only, meaning tasks and other elements cannot be edited. This setting disables all editing features, including task updates, dependency management, and any editing acions.

renderBaseline

boolean

If renderBaseline is set to true, baselines will be rendered for tasks in the Gantt chart. Baselines provide a visual reference to track the planned vs. actual progress of tasks.

resourceFields

ResourceFieldsModel

Defines the mapping properties to extract resource values, such as id, name, unit, and group from the resource collection in the Gantt chart. This helps to map data from a custom resource collection to the appropriate fields for resource allocation.

resourceIDMapping

string

Defines the mapping property to retrieve the resource ID value from the resource collection. This is used to map the resource ID from the resource data to the Gantt chart for resource allocation.

resourceNameMapping

string

Defines the mapping property to retrieve the resource name value from the resource collection. This is used to map the resource name from the resource data to the Gantt chart for task allocation.

resources

object[]

Defines the collection of resources assigned to the project.

rowHeight

number

Defines the height of grid and chart rows in the Gantt chart. This property sets the vertical space allocated for each task or row, allowing customization of row sizes.

searchSettings

SearchSettingsModel

Configures the search functionality within the Gantt chart.

    <div id="Gantt"></div>
    import { Gantt, Filter } from '@syncfusion/ej2-gantt';
    Gantt.Inject(Filter);
    let gantt: Gantt = new Gantt({
        searchSettings: { fields: ['TaskName'], operator: 'contains', key: 'List', ignoreCase: true, hierarchyMode: 'Parent' }
    });
    gantt.appendTo('#Gantt');

segmentData

object[]

Defines the collection of segments assigned to tasks in the Gantt chart.

selectedRowIndex

number

The selectedRowIndex allows you to specify the index of the row to be selected at the time of initial rendering. It can also be used to get the currently selected row index after selection. A value of -1 indicates no row is selected.

selectionSettings

SelectionSettingsModel

Configures the settings for selection in the Gantt chart.

    <div id="Gantt"></div>
    import { Gantt, Selection  } from '@syncfusion/ej2-gantt';
    Gantt.Inject(Selection);
    let gantt: Gantt = new Gantt({
        selectionSettings: {
            mode: 'Row',
            type: 'Multiple'
        }
    });
    gantt.appendTo('#Gantt');

showColumnMenu

boolean

If showColumnMenu set to true, enables the column menu options for each column in the Gantt chart.

showInlineNotes

boolean

To show notes column cell values inside the cell or in tooltip.

showOverAllocation

boolean

If showOverAllocation set to true, enables the rendering of the overallocation container in the Gantt chart.

sortSettings

SortSettingsModel

Configures the sort settings for the Gantt chart.

    <div id="Gantt"></div>
    import { Gantt, Sort } from '@syncfusion/ej2-gantt';
    Gantt.Inject(Sort);
    let gantt: Gantt = new Gantt({
        sortSettings: { columns: [{ field: 'TaskID', direction: 'Ascending' }], allowUnsort: true },
    });
    gantt.appendTo('#Gantt');

splitterSettings

SplitterSettingsModel

Configures the splitter settings for the Gantt chart.

    <div id="Gantt"></div>
    import { Gantt } from '@syncfusion/ej2-gantt';
    let gantt: Gantt = new Gantt({
        splitterSettings: {
            position: "50%",
            minimum: "200",
            separatorSize: 5,
            view: 'Default'
        }
    });
    gantt.appendTo('#Gantt');

taskFields

TaskFieldsModel

Defines the mapping properties to extract task-related values, such as ID, start date, end date, duration, and progress, from the data source. This allows the Gantt chart to properly map the provided data to the corresponding task fields and render them accordingly.

    <div id="Gantt"></div>
    import { Gantt } from '@syncfusion/ej2-gantt';
    let gantt: Gantt = new Gantt({
         taskFields: {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            dependency: 'Predecessor',
            progress: 'Progress',
            baselineStartDate: 'BaselineStartDate',
            baselineEndDate: 'BaselineEndDate',
            durationUnit: 'DurationUnit',
            expandState: 'isExpand',
            indicators: 'Indicators',
            milestone: 'Milestone',
            notes: 'info',
            resourceInfo: 'resourceInfo',
            child: 'subtasks',
        },
    });
    gantt.appendTo('#Gantt');

taskMode

ScheduleMode

Specifies task schedule mode for a project.

taskType

TaskType

taskType Specifies the task type for task whether fixedUnit or fixedWork or fixedDuration.

  • fixedUnit: Sets the task type as fixedUnit.
  • fixedWork: Sets the task type as fixedWork.
  • fixedDuration: Sets the task type as fixedDuration.

taskbarHeight

number

Defines height of the taskbar element in the Gantt chart.

taskbarTemplate

string | Function

The task bar template that renders customized child task bars from the given template. This property allows users to define a custom template for rendering child task bars in the Gantt chart.

   <script type="text/x-jsrender" id="TaskbarTemplate">
    <div class="e-gantt-child-taskbar-inner-div e-gantt-child-taskbar"  style="height:100%">
       <div class="e-gantt-child-progressbar-inner-div e-gantt-child-progressbar" style="width:${ganttProperties.progressWidth}px;height:100%">
          <span class="e-task-label" style="position: absolute; z-index: 1; font-size: 12px; color: white; top: 5px; left: 10px; font-family: "Segoe UI"; overflow: hidden; text-overflow: ellipsis; width: 40%; cursor: move;">${taskData.TaskName}</span>
       </div>
    </div>
</script>
    import { Gantt } from '@syncfusion/ej2-gantt';
    let gantt: Gantt = new Gantt({   
    taskbarTemplate: '#TaskbarTemplate'
    });
    gantt.appendTo('#Gantt');

timelineSettings

TimelineSettingsModel

Configures timeline settings of Gantt. Defines default timeline modes or customized top tier mode and bottom tier mode or single tier only.

    <div id="Gantt"></div>
    import { Gantt } from '@syncfusion/ej2-gantt';
    let gantt: Gantt = new Gantt({
        timelineSettings: {
            showTooltip: true,
            timelineUnitSize: 80,
            timelineViewMode: 'Week',
            updateTimescaleView: true,
            weekStartDay: 0,
            weekendBackground: 'red',
            topTier: {
                format: 'MMM dd, yyyy',
                unit: 'Week',
            },
            bottomTier: {
                unit: 'Day',
                format: 'EEE, dd',
                count: 1,
            }
        }
    });
    gantt.appendTo('#Gantt');

timelineTemplate

string | Function

Renders customized html elements for timeline cell from the given template.

timezone

string

By default, task schedule dates are calculated with system time zone. If the Gantt chart is assigned with a specific time zone, then schedule dates are calculated based on the given time zone date value.

toolbar

[]

toolbar defines the toolbar items of the Gantt. It contains built-in and custom toolbar items. If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the Gantt’s toolbar.

The available built-in toolbar items are:

  • Add: Adds a new record.
  • Edit: Edits the selected task.
  • Update: Updates the edited task.
  • Delete: Deletes the selected task.
  • Cancel: Cancels the edit state.
  • Search: Searches tasks by the given key.
  • ExpandAll: Expands all the task of Gantt.
  • CollapseAll: Collapses all the task of Gantt.
  • PrevTimeSpan: Extends timeline with one unit before the timeline start date.
  • NextTimeSpan: Extends timeline with one unit after the timeline finish date.
  • ZoomIn: ZoomIn the Gantt control.
  • ZoomOut: ZoomOut the Gantt control.
  • ZoomToFit: Display the all tasks within the viewable Gantt chart.
  • ExcelExport: To export in Excel format.
  • CsvExport : To export in CSV format.
  • Indent: To indent a task to one level.
  • Outdent: To outdent a task from one level.

tooltipSettings

TooltipSettingsModel

Enables or disables default tooltip of Gantt element and defines customized tooltip for Gantt elements.

    <div id="Gantt"></div>
    import { Gantt } from '@syncfusion/ej2-gantt';
    let gantt: Gantt = new Gantt({
        tooltipSettings: {
            showTooltip: true,
            taskbar: '<div>TaskID: ${TaskID}</div>',
            connectorLine: '<div>Offset : ${offsetString}</div>',
            editing: '<div>Duration : ${duration}</div>',
            baseline: '<div>Baseline StartDate : ${this.getFormatedDate(BaselineStartDate)}</div>'
        }
    });
    gantt.appendTo('#Gantt');

treeColumnIndex

number

To define expander column index in Grid.

undoRedoActions

GanttAction[]

undoRedoActions Defines action items that retain for undo and redo operation.

undoRedoStepsCount

number

Defines number of undo/redo actions that should be stored.

updateOffsetOnTaskbarEdit

boolean

Specifies whether to update offset value on a task for all the predecessor edit actions.

validateManualTasksOnLinking

boolean

If validateManualTasksOnLinking is set to true, it enables date validation while connecting manually scheduled tasks with predecessor.

viewType

ViewType

Defines the view type of the Gantt.

weekWorkingTime

WeekWorkingTimeModel[]

Specifies unique working hours for each weekday in gantt chart to tailor schedules precisely.

width

number | string

Defines the width of the Gantt component container.

workUnit

WorkUnit

workUnit Specifies the work unit for each tasks whether day or hour or minute.

  • day: Sets the work unit as day.
  • hour: Sets the work unit as hour.
  • minute: Sets the work unit as minute.

workWeek

string[]

Defines workweek of project.

zoomingLevels

ZoomTimelineSettings[]

Configure zooming levels of Gantt Timeline.

Contents
Contents

GanttModel

16 Dec 202524 minutes to read

Interface for a class Gantt

Properties

actionBegin EmitType<Object|PageEventArgs|FilterEventArgs|SortEventArgs|ITimeSpanEventArgs|IDependencyEventArgs|ITaskAddedEventArgs|ZoomEventArgs>

Triggers when Gantt actions such as sorting, filtering, searching etc., starts.

actionComplete EmitType<FilterEventArgs|SortEventArgs|ITaskAddedEventArgs|IKeyPressedEventArgs|ZoomEventArgs>

Triggers when Gantt actions such as sorting, filtering, searching etc. are completed.

actionFailure EmitType<FailureEventArgs>

Triggers when actions are failed.

beforeDataBound EmitType<Object>

Triggers before the data is bound to the TreeGrid in the Gantt component.
This event is triggered before any visual elements (taskbars, rows, timelines) are rendered in the DOM.

beforeExcelExport EmitType<Object>

Triggers before Gantt data is exported to Excel file.

beforePdfExport EmitType<Object>

Triggers before Gantt data is exported to PDF document.

beforeTooltipRender EmitType<BeforeTooltipRenderEventArgs>

Triggers before tooltip get rendered.

cellDeselected EmitType<CellDeselectEventArgs>

Triggers when a particular selected cell is deselected.

cellDeselecting EmitType<CellDeselectEventArgs>

Triggers before the selected cell is deselecting.

cellEdit EmitType<CellEditArgs>

This will be triggered a cell get begins to edit.

cellSave EmitType<CellSaveArgs>

Triggers before a cell’s value is saved in the Gantt chart.
This event allows cancellation of the save action.

cellSelected EmitType<CellSelectEventArgs>

Triggers after a cell is selected.

cellSelecting EmitType<CellSelectingEventArgs>

Triggers before any cell selection occurs.

collapsed EmitType<ICollapsingEventArgs>

This will be triggered after the row getting collapsed.

collapsing EmitType<ICollapsingEventArgs>

This will be triggered before the row getting collapsed.

columnDrag EmitType<ColumnDragEventArgs>

Triggers when column header element is dragged (moved) continuously.

columnDragStart EmitType<ColumnDragEventArgs>

Triggers when column header element drag (move) starts.

columnDrop EmitType<ColumnDragEventArgs>

Triggers when a column header element is dropped on the target column.

columnMenuClick EmitType<ColumnMenuClickEventArgs>

Triggers when click on column menu.

columnMenuOpen EmitType<ColumnMenuOpenEventArgs>

Triggers before column menu opens.

contextMenuClick EmitType<CMenuClickEventArgs>

Triggers when click on context menu.

contextMenuOpen EmitType<CMenuOpenEventArgs>

Triggers before context menu opens.

created EmitType<Object>

Triggers when the component is created.

dataBound EmitType<Object>

Triggers when data source is populated in the Grid.

dataStateChange EmitType<DataStateChangeEventArgs>

Triggers when the Gantt actions such as Sorting, Editing etc., are done.
In this event,the current view data and total record count should be assigned to the dataSource based on the action performed.

destroyed EmitType<Object>

Triggers when the component is destroyed.

endEdit EmitType<ITaskbarEditedEventArgs>

This will be triggered when a task get saved by cell edit.

excelExportComplete EmitType<ExcelExportCompleteArgs>

Triggers after Gantt data is exported to Excel file.

excelHeaderQueryCellInfo EmitType<ExcelHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to Excel file.
You can also customize the Excel cells.

excelQueryCellInfo EmitType<ExcelQueryCellInfoEventArgs>

Triggers before exporting each cell to Excel file.
You can also customize the Excel cells.

expanded EmitType<ICollapsingEventArgs>

This will be triggered after the row getting expanded.

expanding EmitType<ICollapsingEventArgs>

This will be triggered before the row getting expanded.

headerCellInfo EmitType<HeaderCellInfoEventArgs>

This will be triggered before the header cell element is appended to the Grid element.

load EmitType<Object>

Triggered before the Gantt control gets rendered.

onMouseMove EmitType<IMouseMoveEventArgs>

This event will be triggered when mouse move on Gantt.

onTaskbarClick EmitType<ITaskbarClickEventArgs>

This event will be triggered when click on taskbar element.

pdfColumnHeaderQueryCellInfo EmitType<PdfColumnHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to PDF document. You can also customize the PDF cells.

pdfExportComplete EmitType<Object>

Triggers after TreeGrid data is exported to PDF document.

pdfQueryCellInfo EmitType<PdfQueryCellInfoEventArgs>

Triggers before exporting each cell to PDF document. You can also customize the PDF cells.

pdfQueryTaskbarInfo EmitType<Object>

Triggers before exporting each taskbar to PDF document. You can also customize the taskbar.

pdfQueryTimelineCellInfo EmitType<PdfQueryTimelineCellInfoEventArgs>

Triggers before exporting each cell to PDF document. You can also customize the PDF cells.

queryCellInfo EmitType<QueryCellInfoEventArgs>

This will be triggered before the header cell element is appended to the Grid element.

queryTaskbarInfo EmitType<IQueryTaskbarInfoEventArgs>

This will be triggered after the taskbar element is appended to the Gantt element.

recordDoubleClick EmitType<RecordDoubleClickEventArgs>

This event will be triggered when double click on record.

resizeStart EmitType<ResizeArgs>

Triggers when column resize starts.

resizeStop EmitType<ResizeArgs>

Triggers when column resize ends.

resizing EmitType<ResizeArgs>

Triggers on column resizing.

rowDataBound EmitType<RowDataBoundEventArgs>

This will be triggered before the row element is appended to the Grid element.

rowDeselected EmitType<RowDeselectEventArgs>

Triggers when a selected row is deselected.

rowDeselecting EmitType<RowDeselectEventArgs>

Triggers before deselecting the selected row.

rowDrag EmitType<RowDragEventArgs>

Triggers when row elements are dragged (moved) continuously.

rowDragStart EmitType<RowDragEventArgs>

Triggers when row element’s drag(move) starts.

rowDragStartHelper EmitType<RowDragEventArgs>

Triggers when row element’s before drag(move).

rowDrop EmitType<RowDragEventArgs>

Triggers when row elements are dropped on the target row.

rowSelected EmitType<RowSelectEventArgs>

Triggers after row selection occurs.

rowSelecting EmitType<RowSelectingEventArgs>

Triggers before row selection occurs.

splitterResizeStart EmitType<ResizeEventArgs>

Triggers when splitter resizing starts.

splitterResized EmitType<ISplitterResizedEventArgs>

Triggers when splitter resizing action completed.

splitterResizing EmitType<ResizingEventArgs>

Triggers when splitter bar was dragging.

taskbarEdited EmitType<ITaskbarEditedEventArgs>

Triggered when a taskbar is dragged and dropped into a new position on the Gantt chart.

taskbarEditing EmitType<ITaskbarEditedEventArgs>

Triggered when a taskbar is in the dragging state on the Gantt chart.

toolbarClick EmitType<ClickEventArgs>

Triggers when toolbar item was clicked.

addDialogFields AddDialogFieldSettingsModel[]

Defines the tabs and fields to be displayed in the add dialog.
If not specified, the fields will be derived from the taskSettings and columns values.

    <ejs-gantt [addDialogFields]="addDialogFields"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public addDialogFields: object[];
    public ngOnInit(): void {
        this.addDialogFields = [
            { type: 'General', headerText: 'General', fields: ['TaskID', 'TaskName'] },
            { type: 'Resources' },
            { type: 'Dependency' },
            { type: 'Notes'}
        ];
    }
}

allowExcelExport boolean

If allowExcelExport set to true, then it will allow the user to export Gantt chart to Excel and CSV file.

allowFiltering boolean

Enables or disables filtering functionality in the Gantt chart.

allowKeyboard boolean

Enables or disables keyboard interactions in the Gantt chart.

allowParentDependency boolean

Specifies whether to allow dependency connection support for parent records.

allowPdfExport boolean

If allowPdfExport set to true, then it will allow the user to export Gantt chart to PDF file.

allowReordering boolean

If allowReordering is set to true, Gantt chart columns can be reordered.
Reordering can be done by drag and drop of a particular column from one index to another index.

allowResizing boolean

Enables column resizing in the Gantt chart when allowResizing is set to true.
When enabled, users can adjust the width of columns by dragging the column borders.

allowRowDragAndDrop boolean

If allowRowDragAndDrop set to true, then it will allow the user to perform row drag and drop action in Gantt chart.

allowSelection boolean

If allowSelection is set to true, it enables row selection in the Gantt chart, and the selected rows are highlighted.

allowSorting boolean

If allowSorting is set to true, it enables sorting of Gantt chart tasks when the column header is clicked.

allowTaskbarDragAndDrop boolean

Defines whether to enable or disable the taskbar drag and drop action in the Gantt chart.

allowTaskbarOverlap boolean

Specifies whether taskbars can overlap in the Gantt chart. To enable overlapping behavior, use this property along with enableMultiTaskbar.

allowUnscheduledTasks boolean

Enables or disables the rendering of unscheduled tasks in the Gantt chart.
When allowUnscheduledTasks set to true, unscheduled tasks will be displayed in the chart.

autoCalculateDateScheduling boolean

Specifies whether to auto calculate the start and end dates based on factors such as working time, holidays, weekends, and task dependencies.

autoFocusTasks boolean

Enables or disables automatic focusing on the taskbar when a task is clicked.

baselineColor string

Specifies the color of the baseline bar in the Gantt chart.

calendarSettings CalendarSettingsModel

Defines the calendar configuration for the project, including working times, holidays, and task-specific calendars.
This setting enables customization of scheduling behavior across the Gantt chart, including:

  • Global working hours and non-working days
  • Holiday definitions with localized labels
  • Task-level calendar overrides via taskFields.calendarId

collapseAllParentTasks boolean

Defines whether all root tasks should be rendered in a collapsed state. When collapseAllParentTasks set to true, all parent tasks will be collapsed by default.

columnMenuItems []

columnMenuItems defines both built-in and custom menu items for the Gantt chart column menu.



The available built-in items are,

  • ColumnChooser - To show/hide the TreeGrid columns.
  • SortAscending - Sort the current column in ascending order.
  • SortDescending - Sort the current column in descending order.
  • AutoFitAll - Auto fit the size of all columns.
  • AutoFit - Auto fit the size of the current column.
  • Filter - Displays filter options based on the filterSettings property.

columns Column[]|string[]|ColumnModel[]

Defines the collection of columns displayed in the Gantt chart grid.
If the columns declaration is empty, the columns are automatically populated based on the taskSettings values.

    <ejs-gantt [columns]="columns"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public columns: object[];
    public ngOnInit(): void {
        this.columns =  [
            { field: 'TaskID', width: '150', headerText: 'Task ID', headerTextAlign: 'Left' allowFiltering: false },
            { field: 'TaskName', clipMode: 'EllipsisWithTooltip' allowEditing: true, hideAtMedia: '(min-width: 700px)' },
            { field: 'Duration', edittype: 'stringedit', allowReordering: true, maxWidth: '400' },
            { field: 'Progress', textAlign: 'Right', allowResizing: false , visible: true, format: 'C' },
            { field: 'StartDate', width: '250', allowSorting: false, minWidth: '200' }
        ];
    }
}

connectorLineBackground string

Defines the background color of the dependency lines (connector lines) in the Gantt chart.
You can set the color as a valid CSS color string (e.g., “red”, “#FF5733”, “rgb(255,0,0)”).

connectorLineWidth number

Defines the width of the dependency lines in the Gantt chart.
The value should be a positive integer, representing the thickness of the lines.

contextMenuItems ContextMenuItem[]|ContextMenuItemModel[]

Defines the built-in and custom items that appear in the context menu of the Gantt chart.
You can use this property to control the content and functionality of the right-click context menu.

    <ejs-gantt [contextMenuItems]="contextMenuItems"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
import { ContextMenuItemModel } from '@syncfusion/ej2-grids';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public contextMenuItems: (string | ContextMenuItemModel)[];
    public ngOnInit(): void {
        this.contextMenuItems = ['AutoFitAll', 'AutoFit', 'TaskInformation', 'DeleteTask', 'Save', 'Cancel', 'SortAscending', 'SortDescending', 'Add', 'DeleteDependency', 'Convert',
        { text: 'Collapse the Row', target: '.e-content', id: 'collapserow' } as ContextMenuItemModel,
        { text: 'Expand the Row', target: '.e-content', id: 'expandrow' } as ContextMenuItemModel,
        ];
    }
}

dataSource Object[]|DataManager|Object

Defines the data source for the Gantt chart, which is used to render rows and tasks.
The dataSource can be an array of JavaScript objects, an instance of DataManager, or a single object.
The array of objects should contain the task data with properties such as TaskID, TaskName, StartDate, EndDate, etc.
This allows dynamic binding of tasks and their relationships (e.g., dependencies, subtasks, progress) to the Gantt chart.

    <ejs-gantt [dataSource]="data"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public data: object[];
    public ngOnInit(): void {
        // Hierarchical data binding.
        this.data =  [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
                ]
            },
        ];
        // Self-referential data binding (Flat data).
        this.data =  [
            { TaskID: 1,TaskName: 'Project Initiation',StartDate: new Date('04/02/2019'),EndDate: new Date('04/21/2019')},
            { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50,ParentId:1 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50, ParentId:1   },
        ];
        //Remote data
        this.data = new DataManager({
            url: 'https://ej2services.syncfusion.com/production/web-services/api/GanttData',
            adaptor: new WebApiAdaptor,
            crossDomain: true
        });
    }
}

dateFormat string

Specifies the date format for displaying dates in the Gantt chart, including in tooltips and grid cells.
By default, the format is determined based on the current culture/locale settings.

dayWorkingTime DayWorkingTimeModel[]

Defines the customized working time for the project to ensure accurate task scheduling, and works only when the timeline is configured with topTier.unit as ‘Day’ and bottomTier.unit as ‘Hour’ or when timelineViewMode is set to ‘Hour’ or ‘Day’.

    <ejs-gantt [dayWorkingTime]="dayWorkingTime"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    piblic dayWokringTime: object[];
    public ngOnInit(): void {
        this.dayWorkingTime = [{ from: 9, to: 18}];
    }
}

disableHtmlEncode boolean

If disableHtmlEncode is set to true, the Gantt component disables HTML entity encoding across the Gantt content, allowing custom HTML elements to be rendered.

durationUnit DurationUnit

durationUnit Specifies the duration unit for each task. The available options are:

  • day: Sets the duration unit to day.
  • hour: Sets the duration unit to hour.
  • minute: Sets the duration unit to minute.

editDialogFields EditDialogFieldSettingsModel[]

Defines the tabs and fields to be displayed in the edit dialog.
If not specified, the fields will be derived from the taskSettings and columns values.

    <ejs-gantt [editDialogFields]="editDialogFields"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public editDialogFields: object[];
    public ngOnInit(): void {
        this.editDialogFields = [
            { type: 'General', headerText: 'General', fields: ['TaskID', 'TaskName'] },
            { type: 'Resources' },
            { type: 'Dependency' },
            { type: 'Notes'}
        ];
    }
}

editSettings EditSettingsModel

Configures the edit settings for the Gantt chart, such as enabling or disabling task modifications.

    <ejs-gantt [editSettings]="editSettings"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
import { EditSettingsModel } from '@syncfusion/ej2-angular-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public editSettings: EditSettingsModel;
    public ngOnInit(): void {
        this.editSettings = {
            allowAdding: true,
            allowEditing: true,
            allowDeleting: true,
            allowTaskbarEditing: true,
            mode:'Auto',
            newRowPosition: 'Top',
            showDeleteConfirmDialog: true
        };
    }
}

emptyRecordTemplate string|Function

Defines a custom template to display when the Gantt chart has no records.
This template replaces the default empty record message and can include text, HTML elements, or images.
Accepts either a template string or an HTML element ID.

enableAdaptiveUI boolean

If enableAdaptiveUI is set to true, the pop-up UI becomes adaptive to smaller screens, enabling better usability for filtering and other features.

enableAutoWbsUpdate boolean

Enables the automatic update of WBS codes when performing actions like sorting, filtering, row drag and drop, and other grid operations that change the task order or hierarchy.
When set to true, the Gantt component will refresh and regenerate the WBS codes dynamically after such actions to ensure the codes remain in sync with the current task structure.

enableContextMenu boolean

If enableContextMenu is set to true, enables the context menu in the Gantt chart.
The context menu provides additional actions that can be accessed by right-clicking on Gantt chart elements

enableCriticalPath boolean

Enables the highlighting of critical tasks in the Gantt Chart that directly affect the project’s end date.
When enabled, tasks that are critical to the project timeline will be visually distinguished by colours.

enableHover boolean

If enableHover is set to true, it enables hover in the Gantt chart and highlights the rows, chart rows, header cells and timeline cells.

enableHtmlSanitizer boolean

Specifies whether to display or remove the untrusted HTML values in the TreeGrid component.
If enableHtmlSanitizer set to true, any potentially harmful strings and scripts are sanitized before rendering.

enableImmutableMode boolean

If enableImmutableMode is set to true, the Gantt Chart will reuse existing rows from previous results instead of
performing a full refresh when Gantt actions are executed.

enableMultiTaskbar boolean

Enables the rendering of child taskbars on the parent row when it is in a collapsed state in the Gantt chart.

enablePersistence boolean

Enable or disable persisting component’s state between page reloads.

enablePredecessorValidation boolean

If enablePredecessorValidation is set to true, enables validation for predecessor links in the Gantt chart.

enableRtl boolean

Enable or disable rendering component in right to left direction.

enableTimelineVirtualization boolean

Enables better performance for projects with a large time span by initially rendering only the visible timeline cells when enableVirtualization is enabled.
Subsequent cells are loaded on horizontal scrolling.

enableUndoRedo boolean

Enables or disables the undo and redo functionality in the Gantt chart.

enableVirtualMaskRow boolean

Specifies whether to display a shimmer effect during scrolling in the virtual scrolling feature when enableVirtualization is enabled. If disabled, a spinner is shown instead of the shimmer effect.

enableVirtualization boolean

If enableVirtualization is set to true, the Gantt chart will render only the rows visible within the viewport.
and load subsequent rows as the user scrolls vertically. This improves performance when dealing with large datasets.

enableWBS boolean

Enables Work Breakdown Structure (WBS) functionality in the Gantt Chart.
When set to true, the Gantt Chart automatically generates WBS codes based on the task hierarchy.
A dedicated WBS Code column will be shown to represent the task structure.
Additionally, if task dependencies (predecessors) are mapped in the data source, a WBS Predecessor column will also be displayed to reflect dependency information using WBS codes.

eventMarkers EventMarkerModel[]

Defines the events and milestones along the project timeline.
These event markers indicate significant events or milestones throughout the project’s duration.

    <ejs-gantt [eventMarkers]="eventMarkers"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public eventMarkers : object[];
    public ngOnInit(): void {
        this.eventMarkers = [
            {
                day: new Date('04/10/2019'),
                label: 'Project approval and kick-off',
                cssClass: 'e-custom-event-marker',
            }
        ];
    }
}

filterSettings FilterSettingsModel

Configures the filter settings for the Gantt chart, enabling users to filter tasks based on specific columns or criteria.
The filterSettings property allows customization of filter behavior, such as which columns to filter and the filter type.

    <ejs-gantt [filterSettings]="filterSettings"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public filterSettings: object;
    public ngOnInit(): void {
        this.filterSettings = {
            columns: [{ field: 'TaskName', matchCase: false, operator: 'startswith', predicate: 'and', value: 'Identify' },{ field: 'TaskID', matchCase: false, operator: 'equal', predicate: 'and', value: 2 }],
            ignoreAccent: true
        };
    }
}

frozenColumns number

Specifies the number of columns that should remain visible and fixed on the left side of the Gantt during horizontal scrolling.
This feature ensures key columns, such as identifiers, stay visible while users scroll through data.

gridLines GridLine

Configures the grid lines displayed in the TreeGrid and Gantt chart.
The gridLines property allows customization of the type of grid lines to be shown, either horizontal, vertical, both or none.

height number|string

Defines the height of the Gantt component container.
The height property can be set to a specific value (in pixels or percentage) or set to ‘auto’ for automatic height adjustment based on content.

highlightWeekends boolean

If highlightWeekends is set to true, it highlights all weekend days in the week-day timeline mode.
This makes weekends visually distinct in the timeline view.

holidays HolidayModel[]

Defines holidays within the project timeline, allowing you to mark specific dates as holidays.
This helps in accounting for non-working days in scheduling and task planning.

    <ejs-gantt [holidays] = "holidays"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public holidays: object[];
    public ngOnInit(): void {
        this.holidays = [{
            from: "04/04/2019",
            to:"04/05/2019",
            label: " Public holidays",
            cssClass:"e-custom-holiday"
        }];
    }
}

includeWeekend boolean

Defines whether weekend days should be considered as working days in the Gantt chart.
When includeWeekend set to true, weekends (Saturday and Sunday) are treated as regular working days.

labelSettings LabelSettingsModel

Configures the labels displayed on the right, left, and inside the taskbars in the Gantt chart.

    <ejs-gantt [labelSettings]="labelSettings"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public labelSettings: object;
    public ngOnInit(): void {
        this.labelSettings = {
            leftLabel: 'Task ID: ${taskData.TaskID}',
            rightLabel:'Progress Value: ${taskData.Progress}',
            taskLabel: '${Progress}%'
        }
    }
}

loadChildOnDemand boolean

Gets or sets whether to load child records on demand in remote data binding. When loadChildOnDemand set to true, child records are loaded only when expanded, and parent records are rendered in a collapsed state initially.

loadingIndicator LoadingIndicatorModel

Specifies the type of loading indicator to display during scrolling action in the virtual scrolling feature when enableVirtualization is enabled.

locale string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

milestoneTemplate string|Function

Defines a custom template for rendering milestone tasks in the Gantt chart. This template allows you to customize the appearance of milestone tasks.

parentTaskbarTemplate string|Function

Defines a custom template for rendering parent task bars in the Gantt chart. This template allows you to customize the appearance of parent task bars.

  <ejs-gantt id="ganttDefault">
    <ng-template #parentTaskbarTemplate let-data>
      <div
        class="e-gantt-parent-taskbar-inner-div e-gantt-parent-taskbar"
        [style.width.px]="data.ganttProperties.width"
        style="height:22px;margin-top:-1px;"
        tabindex="-1"
      >
        <div
          class="e-gantt-parent-progressbar-inner-div e-gantt-parent-progressbar"
          style="border-style:solid;border-top-right-radius:0px;border-bottom-right-radius:0px;height:100%;"
          [style.width.px]="calculateProgressWidth(data)"
        >
          <span
            class="e-task-label"
            style="line-height:21px; text-align:left;display:inline-block;width:122px; height:22px;"
            >{{ data.TaskName }}</span
          >
        </div>
      </div>
    </ng-template>
  </ejs-gantt>
import { Component, ViewEncapsulation, OnInit,IGanttData } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
   public calculateProgressWidth(data:IGanttData) {
    // Calculate the progress width based on the taskbar width and progress value
    return (data.ganttProperties.progress * data.ganttProperties.width) / 100;
   }
   public ngOnInit(): void {

   }
}

projectEndDate Date|string

Defines the end date of the project. If the projectEndDate is not set, it will be automatically calculated based on the data source.
The date can be provided as a Date object or a string in a valid date format.

projectStartDate Date|string

Defines the start date of the project. If the projectStartDate is not set, it will be automatically calculated based on the data source.
The date can be provided as a Date object or a string in a valid date format.

query Query

Defines an external Query
that will be executed in conjunction with data processing to filter, sort the data.
This allows for advanced data manipulation before binding the data to the Gantt chart.

readOnly boolean

If readOnly is set to true, the Gantt chart becomes read-only, meaning tasks and other elements cannot be edited.
This setting disables all editing features, including task updates, dependency management, and any editing acions.

renderBaseline boolean

If renderBaseline is set to true, baselines will be rendered for tasks in the Gantt chart.
Baselines provide a visual reference to track the planned vs. actual progress of tasks.

resourceFields ResourceFieldsModel

Defines the mapping properties to extract resource values, such as id, name, unit, and group from the resource collection in the Gantt chart.
This helps to map data from a custom resource collection to the appropriate fields for resource allocation.

resourceIDMapping string

Defines the mapping property to retrieve the resource ID value from the resource collection.
This is used to map the resource ID from the resource data to the Gantt chart for resource allocation.

resourceNameMapping string

Defines the mapping property to retrieve the resource name value from the resource collection.
This is used to map the resource name from the resource data to the Gantt chart for task allocation.

resources object[]

Defines the collection of resources assigned to the project.

rowHeight number

Defines the height of grid and chart rows in the Gantt chart.
This property sets the vertical space allocated for each task or row, allowing customization of row sizes.

searchSettings SearchSettingsModel

Configures the search functionality within the Gantt chart.

    <ejs-gantt [searchSettings]="searchSettings"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
import { SearchSettingsModel } from '@syncfusion/ej2-angular-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public searchSettings: SearchSettingsModel;
    public ngOnInit(): void {
        this.searchSettings = { fields: ['TaskName'], operator: 'contains', key: 'product', ignoreCase: true hierarchyMode: 'Parent'}
    }
}

segmentData object[]

Defines the collection of segments assigned to tasks in the Gantt chart.

selectedRowIndex number

The selectedRowIndex allows you to specify the index of the row to be selected at the time of initial rendering.
It can also be used to get the currently selected row index after selection.
A value of -1 indicates no row is selected.

selectionSettings SelectionSettingsModel

Configures the settings for selection in the Gantt chart.

    <ejs-gantt [selectionSettings]="selectionSettings"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';
import { SelectionSettingsModel } from '@syncfusion/ej2-angular-grids';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public selectionSettings: SelectionSettingsModel;
    public ngOnInit(): void {
        this.selectionSettings = {
            mode: 'Row',
            type: 'Multiple'
        };
    }
}

showColumnMenu boolean

If showColumnMenu set to true, enables the column menu options for each column header in the Gantt chart.

showInlineNotes boolean

To show notes column cell values inside the cell or in tooltip.

showOverAllocation boolean

If showOverAllocation set to true, enables the rendering of the overallocation container in the Gantt chart.

sortSettings SortSettingsModel

Configures the sort settings for the Gantt chart.

    <ejs-gantt [sortSettings]="sortSettings"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public sortSettings: object;
    public ngOnInit(): void {
        this.sortSettings = { columns: [{ field: 'TaskID', direction: 'Descending' }], allowUnsort: true };
    }
}

splitterSettings SplitterSettingsModel

Configures the splitter settings for the Gantt chart.

    <ejs-gantt [splitterSettings]="splitterSettings"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public splitterSettings: object;
    public ngOnInit(): void {
        this.splitterSettings = {
            position: "50%",
            minimum: "200",
            separatorSize: 5,
            view: 'Default'
        }
    }
}

taskFields TaskFieldsModel

Defines the mapping properties to extract task-related values, such as ID, start date, end date, duration, and progress, from the data source.
This allows the Gantt chart to properly map the provided data to the corresponding task fields and render them accordingly.

    <ejs-gantt [taskFields]="taskSettings"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public taskSettings: object;
    public ngOnInit(): void {
         this.taskSettings = {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            dependency: 'Predecessor',
            progress: 'Progress',
            baselineStartDate: 'BaselineStartDate',
            baselineEndDate: 'BaselineEndDate',
            durationUnit: 'DurationUnit',
            expandState: 'isExpand',
            indicators: 'Indicators',
            milestone: 'Milestone',
            notes: 'info',
            resourceInfo: 'resourceInfo',
            child: 'subtasks',
        };
    }
}

taskMode ScheduleMode

Specifies task schedule mode for a project.

taskType TaskType

taskType Specifies the task type for task whether fixedUnit or fixedWork or fixedDuration.

  • fixedUnit: Sets the task type as fixedUnit.
  • fixedWork: Sets the task type as fixedWork.
  • fixedDuration: Sets the task type as fixedDuration.

taskbarHeight number

Defines height of the taskbar element in the Gantt chart.

taskbarTemplate string|Function

The task bar template that renders customized child task bars from the given template.
This property allows users to define a custom template for rendering child task bars in the Gantt chart.

  <ejs-gantt id="ganttDefault">
    <ng-template #taskbarTemplate let-data>
      <div
        class="e-gantt-child-taskbar-inner-div e-gantt-child-taskbar"
        style="height:22px; margin-top :-1px"
        tabindex="-1"
        [style.width.px]="data.ganttProperties.width"
      >
        <div
          class="e-gantt-child-progressbar-inner-div e-gantt-child-progressbar"
          style="border-style:solid;height:100%;border-top-right-radius:0px;border-bottom-right-radius:0px;"
          [style.width.px]="calculateProgressWidth(data)"
        >
          <span
            class="e-task-label"
            style="line-height:21px; text-align:left;display:inline-block;width:122px; height:22px;"
            >{{ data.TaskName }}</span
          >
        </div>
      </div>
    </ng-template>
  </ejs-gantt>
import { Component, ViewEncapsulation, OnInit,IGanttData } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
   public calculateProgressWidth(data:IGanttData) {
    // Calculate the progress width based on the taskbar width and progress value
    return (data.ganttProperties.progress * data.ganttProperties.width) / 100;
   }
   public ngOnInit(): void {

   }
}

timelineSettings TimelineSettingsModel

Configures timeline settings of Gantt.
Defines default timeline modes or customized top tier mode and bottom tier mode or single tier only.

    <ejs-gantt [timelineSettings]="timelineSettings"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public timelineSettings: object;
    public ngOnInit(): void {
        this.timelineSettings = {
            showTooltip: true,
            timelineUnitSize: 80,
            timelineViewMode: 'Week',
            updateTimescaleView: true,
            weekStartDay: 0,
            weekendBackground: 'red',
            topTier: {
                format: 'MMM dd, yyyy',
                unit: 'Week',
            },
            bottomTier: {
                unit: 'Day',
                format: 'EEE, dd',
                count: 1,
            }
        };
    }
}

timelineTemplate string|Function

Renders customized html elements for timeline cell from the given template.

timezone string

By default, task schedule dates are calculated with system time zone. If the Gantt chart is assigned with a specific time zone, then schedule dates are calculated based on the given time zone date value.
This property function properly when the timeline displays hours. To enable this, set timelineViewMode to ‘Hour’ or configure topTier.unit as ‘Day’ and bottomTier.unit as ‘Hour’.

toolbar []

toolbar defines the toolbar items of the Gantt.
It contains built-in and custom toolbar items.
If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the Gantt’s toolbar.


The available built-in toolbar items are:

  • Add: Adds a new record.
  • Edit: Edits the selected task.
  • Update: Updates the edited task.
  • Delete: Deletes the selected task.
  • Cancel: Cancels the edit state.
  • Search: Searches tasks by the given key.
  • ExpandAll: Expands all the task of Gantt.
  • CollapseAll: Collapses all the task of Gantt.
  • PrevTimeSpan: Extends timeline with one unit before the timeline start date.
  • NextTimeSpan: Extends timeline with one unit after the timeline finish date.
  • ZoomIn: ZoomIn the Gantt control.
  • ZoomOut: ZoomOut the Gantt control.
  • ZoomToFit: Display the all tasks within the viewable Gantt chart.
  • ExcelExport: To export in Excel format.
  • CsvExport : To export in CSV format.
  • Indent: To indent a task to one level.
  • Outdent: To outdent a task from one level.

tooltipSettings TooltipSettingsModel

Enables or disables default tooltip of Gantt element and defines customized tooltip for Gantt elements.

    <ejs-gantt [tooltipSettings]="tooltipSettings"></ejs-gantt>
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { Gantt } from '@syncfusion/ej2-gantt';

@Component({
    selector: 'app-root',
    templateUrl: "app.component.html",
    encapsulation: ViewEncapsulation.None
})
export class AppComponent{
    public tooltipSettings: object;
    public ngOnInit(): void {
        this.tooltipSettings = {
            showTooltip: true,
            taskbar: '<div>TaskID: ${TaskID}</div>',
            connectorLine: '<div>Offset : ${offsetString}</div>',
            editing: '<div>Duration : ${duration}</div>',
            baseline: '<div>Baseline StartDate : ${this.getFormatedDate(BaselineStartDate)}</div>'
        }
    }
}

treeColumnIndex number

To define expander column index in Grid.

undoRedoActions GanttAction[]

undoRedoActions Defines action items that retain for undo and redo operation.

undoRedoStepsCount number

Defines number of undo/redo actions that should be stored.

updateOffsetOnTaskbarEdit boolean

Specifies whether to update offset value on a task for all the predecessor edit actions.

validateManualTasksOnLinking boolean

If validateManualTasksOnLinking is set to true,
it enables date validation while connecting manually scheduled tasks with predecessor.

viewType ViewType

Defines the view type of the Gantt.

weekWorkingTime WeekWorkingTimeModel[]

Specifies the working days in a week for accurate planning, and works only when the timeline is configured with topTier.unit as ‘Day’ and bottomTier.unit as ‘Hour’ or when timelineViewMode is set to ‘Hour’ or ‘Day’.

width number|string

Defines the width of the Gantt component container.

workUnit WorkUnit

workUnit Specifies the work unit for each tasks whether day or hour or minute.

  • day: Sets the work unit as day.
  • hour: Sets the work unit as hour.
  • minute: Sets the work unit as minute.

workWeek string[]

Defines workweek of project.

zoomingLevels ZoomTimelineSettings[]

Configure zooming levels of Gantt Timeline.

Search results

GanttModel API in Vue Gantt API component

Interface for a class Gantt

Properties

actionBegin

EmitType<``Object|PageEventArgs|FilterEventArgs|SortEventArgs|ITimeSpanEventArgs|IDependencyEventArgs|ITaskAddedEventArgs|ZoomEventArgs>

Triggers when Gantt actions such as sorting, filtering, searching etc., starts.

actionComplete

EmitType<``FilterEventArgs|SortEventArgs|ITaskAddedEventArgs|IKeyPressedEventArgs|ZoomEventArgs>

Triggers when Gantt actions such as sorting, filtering, searching etc. are completed.

actionFailure

EmitType<FailureEventArgs>

Triggers when actions are failed.

beforeExcelExport

EmitType<Object>

Triggers before Gantt data is exported to Excel file.

beforePdfExport

EmitType<Object>

Triggers before Gantt data is exported to PDF document.

beforeTooltipRender

EmitType<BeforeTooltipRenderEventArgs>

Triggers before tooltip get rendered.

cellDeselected

EmitType<CellDeselectEventArgs>

Triggers when a particular selected cell is deselected.

cellDeselecting

EmitType<CellDeselectEventArgs>

Triggers before the selected cell is deselecting.

cellEdit

EmitType<CellEditArgs>

This will be triggered a cell get begins to edit.

cellSelected

EmitType<CellSelectEventArgs>

Triggers after a cell is selected.

cellSelecting

EmitType<CellSelectingEventArgs>

Triggers before any cell selection occurs.

collapsed

EmitType<ICollapsingEventArgs>

This will be triggered after the row getting collapsed.

collapsing

EmitType<ICollapsingEventArgs>

This will be triggered before the row getting collapsed.

columnDrag

EmitType<ColumnDragEventArgs>

Triggers when column header element is dragged (moved) continuously.

columnDragStart

EmitType<ColumnDragEventArgs>

Triggers when column header element drag (move) starts.

columnDrop

EmitType<ColumnDragEventArgs>

Triggers when a column header element is dropped on the target column.

columnMenuClick

EmitType<ColumnMenuClickEventArgs>

Triggers when click on column menu.

columnMenuOpen

EmitType<ColumnMenuOpenEventArgs>

Triggers before column menu opens.

contextMenuClick

EmitType<CMenuClickEventArgs>

Triggers when click on context menu.

contextMenuOpen

EmitType<CMenuOpenEventArgs>

Triggers before context menu opens.

created

EmitType<Object>

Triggers when the component is created.

dataBound

EmitType<Object>

Triggers when data source is populated in the Grid.

dataStateChange

EmitType<DataStateChangeEventArgs>

Triggers when the Gantt actions such as Sorting, Editing etc., are done. In this event,the current view data and total record count should be assigned to the dataSource based on the action performed.

destroyed

EmitType<Object>

Triggers when the component is destroyed.

endEdit

EmitType<ITaskbarEditedEventArgs>

This will be triggered when a task get saved by cell edit.

excelExportComplete

EmitType<ExcelExportCompleteArgs>

Triggers after Gantt data is exported to Excel file.

excelHeaderQueryCellInfo

EmitType<ExcelHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to Excel file. You can also customize the Excel cells.

excelQueryCellInfo

EmitType<ExcelQueryCellInfoEventArgs>

Triggers before exporting each cell to Excel file. You can also customize the Excel cells.

expanded

EmitType<ICollapsingEventArgs>

This will be triggered after the row getting expanded.

expanding

EmitType<ICollapsingEventArgs>

This will be triggered before the row getting expanded.

headerCellInfo

EmitType<HeaderCellInfoEventArgs>

This will be triggered before the header cell element is appended to the Grid element.

load

EmitType<Object>

Triggered before the Gantt control gets rendered.

onMouseMove

EmitType<IMouseMoveEventArgs>

This event will be triggered when mouse move on Gantt.

onTaskbarClick

EmitType<ITaskbarClickEventArgs>

This event will be triggered when click on taskbar element.

pdfColumnHeaderQueryCellInfo

EmitType<PdfColumnHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to PDF document. You can also customize the PDF cells.

pdfExportComplete

EmitType<Object>

Triggers after TreeGrid data is exported to PDF document.

pdfQueryCellInfo

EmitType<PdfQueryCellInfoEventArgs>

Triggers before exporting each cell to PDF document. You can also customize the PDF cells.

pdfQueryTaskbarInfo

EmitType<Object>

Triggers before exporting each taskbar to PDF document. You can also customize the taskbar.

pdfQueryTimelineCellInfo

EmitType<PdfQueryTimelineCellInfoEventArgs>

Triggers before exporting each cell to PDF document. You can also customize the PDF cells.

queryCellInfo

EmitType<QueryCellInfoEventArgs>

This will be triggered before the header cell element is appended to the Grid element.

queryTaskbarInfo

EmitType<IQueryTaskbarInfoEventArgs>

This will be triggered after the taskbar element is appended to the Gantt element.

recordDoubleClick

EmitType<RecordDoubleClickEventArgs>

This event will be triggered when double click on record.

resizeStart

EmitType<ResizeArgs>

Triggers when column resize starts.

resizeStop

EmitType<ResizeArgs>

Triggers when column resize ends.

resizing

EmitType<ResizeArgs>

Triggers on column resizing.

rowDataBound

EmitType<RowDataBoundEventArgs>

This will be triggered before the row element is appended to the Grid element.

rowDeselected

EmitType<RowDeselectEventArgs>

Triggers when a selected row is deselected.

rowDeselecting

EmitType<RowDeselectEventArgs>

Triggers before deselecting the selected row.

rowDrag

EmitType<RowDragEventArgs>

Triggers when row elements are dragged (moved) continuously.

rowDragStart

EmitType<RowDragEventArgs>

Triggers when row element’s drag(move) starts.

rowDragStartHelper

EmitType<RowDragEventArgs>

Triggers when row element’s before drag(move).

rowDrop

EmitType<RowDragEventArgs>

Triggers when row elements are dropped on the target row.

rowSelected

EmitType<RowSelectEventArgs>

Triggers after row selection occurs.

rowSelecting

EmitType<RowSelectingEventArgs>

Triggers before row selection occurs.

splitterResizeStart

EmitType<ResizeEventArgs>

Triggers when splitter resizing starts.

splitterResized

EmitType<ISplitterResizedEventArgs>

Triggers when splitter resizing action completed.

splitterResizing

EmitType<ResizingEventArgs>

Triggers when splitter bar was dragging.

taskbarEdited

EmitType<ITaskbarEditedEventArgs>

Triggered when a taskbar is dragged and dropped into a new position on the Gantt chart.

taskbarEditing

EmitType<ITaskbarEditedEventArgs>

Triggered when a taskbar is in the dragging state on the Gantt chart.

toolbarClick

EmitType<ClickEventArgs>

Triggers when toolbar item was clicked.

UpdateOffsetOnTaskbarEdit

boolean

Specifies whether to update offset value on a task for all the predecessor edit actions.

addDialogFields

AddDialogFieldSettingsModel[]

Defines the tabs and fields to be displayed in the add dialog. If not specified, the fields will be derived from the taskSettings and columns values.

    <template>
        <ejs-gantt :addDialogFields="addDialogFields"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                addDialogFields : [
                    { type: 'General', headerText: 'General', fields: ['TaskID', 'TaskName'] },
                    { type: 'Resources' },
                    { type: 'Dependency' },
                    { type: 'Notes'}
                ];
            }
        provide: { }
    }});
</script>

allowExcelExport

boolean

If allowExcelExport set to true, then it will allow the user to export Gantt chart to Excel and CSV file.

allowFiltering

boolean

Enables or disables filtering functionality in the Gantt chart.

allowKeyboard

boolean

Enables or disables keyboard interactions in the Gantt chart.

allowParentDependency

boolean

Specifies whether to allow dependency connection support for parent records.

allowPdfExport

boolean

If allowPdfExport set to true, then it will allow the user to export Gantt chart to PDF file.

allowReordering

boolean

If allowReordering is set to true, Gantt chart columns can be reordered. Reordering can be done by drag and drop of a particular column from one index to another index.

allowResizing

boolean

Enables column resizing in the Gantt chart when allowResizing is set to true. When enabled, users can adjust the width of columns by dragging the column borders.

allowRowDragAndDrop

boolean

If allowRowDragAndDrop set to true, then it will allow the user to perform row drag and drop action in Gantt chart.

allowSelection

boolean

If allowSelection is set to true, it enables row selection in the Gantt chart, and the selected rows are highlighted.

allowSorting

boolean

If allowSorting is set to true, it enables sorting of Gantt chart tasks when the column header is clicked.

allowTaskbarDragAndDrop

boolean

Defines whether to enable or disable the taskbar drag and drop action in the Gantt chart.

allowTaskbarOverlap

boolean

Specifies whether taskbars can overlap in the Gantt chart.

allowUnscheduledTasks

boolean

Enables or disables the rendering of unscheduled tasks in the Gantt chart. When allowUnscheduledTasks set to true, unscheduled tasks will be displayed in the chart.

autoCalculateDateScheduling

boolean

Specifies whether to auto calculate the start and end dates based on factors such as working time, holidays, weekends, and task dependencies.

autoFocusTasks

boolean

Enables or disables automatic focusing on the taskbar when a task is clicked.

baselineColor

string

Specifies the color of the baseline bar in the Gantt chart.

collapseAllParentTasks

boolean

Defines whether all root tasks should be rendered in a collapsed state. When collapseAllParentTasks set to true, all parent tasks will be collapsed by default.

columnMenuItems

[]

columnMenuItems defines both built-in and custom menu items for the Gantt chart column menu.

The available built-in items are,

  • ColumnChooser - To show/hide the TreeGrid columns.
  • SortAscending - Sort the current column in ascending order.
  • SortDescending - Sort the current column in descending order.
  • AutoFitAll - Auto fit the size of all columns.
  • AutoFit - Auto fit the size of the current column.
  • Filter - Displays filter options based on the filterSettings property.

columns

Column[] | string[] | ColumnModel[]

Defines the collection of columns displayed in the Gantt chart grid. If the columns declaration is empty, the columns are automatically populated based on the taskSettings values.

    <template>
        <ejs-gantt :columns = "columns"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                columns: [
                    { field: 'TaskID', width: '150', headerText: 'Task ID', headerTextAlign: 'Left' allowFiltering: false },
                    { field: 'TaskName', clipMode: 'EllipsisWithTooltip' allowEditing: true, hideAtMedia: '(min-width: 700px)' },
                    { field: 'Duration', edittype: 'stringedit', allowReordering: true, maxWidth: '400' },
                    { field: 'Progress', textAlign: 'Right', allowResizing: false , visible: true, format: 'C' },
                    { field: 'StartDate', width: '250', allowSorting: false, minWidth: '200' }
                ]
            }
        provide: { }
    }});
</script>

connectorLineBackground

string

Defines the background color of the dependency lines (connector lines) in the Gantt chart. You can set the color as a valid CSS color string (e.g., “red”, “#FF5733”, “rgb(255,0,0)”).

connectorLineWidth

number

Defines the width of the dependency lines in the Gantt chart. The value should be a positive integer, representing the thickness of the lines.

contextMenuItems

ContextMenuItem[] | ContextMenuItemModel[]

Defines the built-in and custom items that appear in the context menu of the Gantt chart. You can use this property to control the content and functionality of the right-click context menu.

    <template>
        <ejs-gantt :contextMenuItems="contextMenuItems"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, ContextMenu } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                contextMenuItems: ['AutoFitAll', 'AutoFit', 'TaskInformation', 'DeleteTask', 'Save', 'Cancel', 'SortAscending', 'SortDescending', 'Add', 'DeleteDependency', 'Convert',
                { text: 'Collapse the Row', target: '.e-content', id: 'collapserow' },
                { text: 'Expand the Row', target: '.e-content', id: 'expandrow' },
                ],
            }
        provide: {gantt: [ ContextMenu ]}
    }});
</script>

dataSource

Object[] | DataManager | Object

Defines the data source for the Gantt chart, which is used to render rows and tasks. The dataSource can be an array of JavaScript objects, an instance of DataManager, or a single object. The array of objects should contain the task data with properties such as TaskID, TaskName, StartDate, EndDate, etc. This allows dynamic binding of tasks and their relationships (e.g., dependencies, subtasks, progress) to the Gantt chart.

    <template>
        <ejs-gantt :dataSource="data"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                // Hierarchical data binding.
                data: [
                    {
                        TaskID: 1,
                        TaskName: 'Project Initiation',
                        StartDate: new Date('04/02/2019'),
                        EndDate: new Date('04/21/2019'),
                        subtasks: [
                            { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 }
                        ]
                    },
                ],
                // Self-referential data binding (Flat data).
                data = [
                    { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
                    { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50, ParentId: 1 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50, ParentId: 1 }
                ];
                // Remote data
                data: new DataManager({
                    url: 'https://ej2services.syncfusion.com/production/web-services/api/GanttData',
                    adaptor: new WebApiAdaptor,
                    crossDomain: true
                }),
            }
        provide: {}
    }});
</script>

dateFormat

string

Specifies the date format for displaying dates in the Gantt chart, including in tooltips and grid cells. By default, the format is determined based on the current culture/locale settings.

dayWorkingTime

DayWorkingTimeModel[]

Defines the customized working time for the project. This helps in accurately planning tasks based on available working hours and ensures proper task scheduling.

    <template>
        <ejs-gantt :dayWorkingTime="dayWorkingTime"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                dayWorkingTime: [{ from: 9, to: 18 }],
            }
        provide: {}
    }});
</script>

disableHtmlEncode

boolean

If disableHtmlEncode is set to true, the Gantt component disables HTML entity encoding across the Gantt content, allowing custom HTML elements to be rendered.

durationUnit

DurationUnit

durationUnit Specifies the duration unit for each task. The available options are:

  • day: Sets the duration unit to day.
  • hour: Sets the duration unit to hour.
  • minute: Sets the duration unit to minute.

editDialogFields

EditDialogFieldSettingsModel[]

Defines the tabs and fields to be displayed in the edit dialog. If not specified, the fields will be derived from the taskSettings and columns values.

    <template>
        <ejs-gantt :editDialogFields="editDialogFields"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                editDialogFields : [
                    { type: 'General', headerText: 'General', fields: ['TaskID', 'TaskName'] },
                    { type: 'Resources' },
                    { type: 'Dependency' },
                    { type: 'Notes'}
                ];
            }
        provide: { }
    }});
</script>

editSettings

EditSettingsModel

Configures the edit settings for the Gantt chart, such as enabling or disabling task modifications.

    <template>
        <ejs-gantt :editSettings= "editSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, Edit } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                allowAdding: true,
                allowEditing: true,
                allowDeleting: true,
                allowTaskbarEditing: true,
                mode:'Auto',
                newRowPosition: 'Top',
                showDeleteConfirmDialog: true
            },
        }
        provide: { gantt: [ Edit ] }
    }});
</script>

enableAdaptiveUI

boolean

If enableAdaptiveUI is set to true, the pop-up UI becomes adaptive to smaller screens, enabling better usability for filtering and other features.

enableContextMenu

boolean

If enableContextMenu is set to true, enables the context menu in the Gantt chart. The context menu provides additional actions that can be accessed by right-clicking on Gantt chart elements

enableCriticalPath

boolean

Enables the highlighting of critical tasks in the Gantt Chart that directly affect the project’s end date. When enabled, tasks that are critical to the project timeline will be visually distinguished by colours.

enableHtmlSanitizer

boolean

Specifies whether to display or remove the untrusted HTML values in the TreeGrid component. If enableHtmlSanitizer set to true, any potentially harmful strings and scripts are sanitized before rendering.

enableImmutableMode

boolean

If enableImmutableMode is set to true, the Gantt Chart will reuse existing rows from previous results instead of performing a full refresh when Gantt actions are executed.

enableMultiTaskbar

boolean

Enables the rendering of child taskbars on the parent row when it is in a collapsed state in the Gantt chart.

enablePersistence

boolean

Enable or disable persisting component’s state between page reloads.

enablePredecessorValidation

boolean

If enablePredecessorValidation is set to true, enables validation for predecessor links in the Gantt chart.

enableRtl

boolean

Enable or disable rendering component in right to left direction.

enableTimelineVirtualization

boolean

Enables better performance for projects with a large time span by initially rendering only the visible timeline cells. Subsequent cells are loaded on horizontal scrolling.

enableUndoRedo

boolean

Enables or disables the undo and redo functionality in the Gantt chart.

enableVirtualMaskRow

boolean

Specifies whether to display shimmer effect during scrolling action in virtual scrolling feature. If disabled, spinner is shown instead of shimmer effect.

enableVirtualization

boolean

If enableVirtualization is set to true, the Gantt chart will render only the rows visible within the viewport. and load subsequent rows as the user scrolls vertically. This improves performance when dealing with large datasets.

eventMarkers

EventMarkerModel[]

Defines the events and milestones along the project timeline. These event markers indicate significant events or milestones throughout the project’s duration.

    <template>
        <ejs-gantt :eventMarkers = "eventMarkers"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, DayMarkers  } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                eventMarkers: [
                {
                    day: '04/10/2019',
                    cssClass: 'e-custom-event-marker',
                    label: 'Project approval and kick-off'
                }]
            },
        }
        provide: { gantt: [ DayMarkers ] }
    }});
</script>

filterSettings

FilterSettingsModel

Configures the filter settings for the Gantt chart, enabling users to filter tasks based on specific columns or criteria. The filterSettings property allows customization of filter behavior, such as which columns to filter and the filter type.

    <template>
        <ejs-gantt :filterSettings="filterSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, Filter } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                filterSettings: {
                    columns: [{ field: 'TaskName', matchCase: false, operator: 'startswith', predicate: 'and', value: 'Identify' },{ field: 'TaskID', matchCase: false, operator: 'equal', predicate: 'and', value: 2 }],
                    ignoreAccent: true
               },
            },
        }
        provide: { gantt: [ Filter  ] }
    }});
</script>

gridLines

GridLine

Configures the grid lines displayed in the TreeGrid and Gantt chart. The gridLines property allows customization of the type of grid lines to be shown, either horizontal, vertical, or both.

height

number | string

Defines the height of the Gantt component container. The height property can be set to a specific value (in pixels or percentage) or set to ‘auto’ for automatic height adjustment based on content.

highlightWeekends

boolean

If highlightWeekends is set to true, it highlights all weekend days in the week-day timeline mode. This makes weekends visually distinct in the timeline view.

holidays

HolidayModel[]

Defines holidays within the project timeline, allowing you to mark specific dates as holidays. This helps in accounting for non-working days in scheduling and task planning.

    <template>
        <ejs-gantt :holidays = "holidays"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, DayMarkers  } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                holidays: [{
                    from: "04/04/2019",
                    to:"04/05/2019",
                    label: " Public holidays",
                    cssClass:"e-custom-holiday"
                }]
            },
        }
        provide: { gantt: [ DayMarkers ] }
    }});
</script>

includeWeekend

boolean

Defines whether weekend days should be considered as working days in the Gantt chart. When includeWeekend set to true, weekends (Saturday and Sunday) are treated as regular working days.

labelSettings

LabelSettingsModel

Configures the labels displayed on the right, left, and inside the taskbars in the Gantt chart.

    <template>
        <ejs-gantt :labelSettings="labelSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                labelSettings: {
                    leftLabel: 'Task ID: ${taskData.TaskID}',
                    rightLabel:'Progress Value: ${taskData.Progress}',
                    taskLabel: '${Progress}%'
                },
            },
        }
        provide: { }
    }});
</script>

loadChildOnDemand

boolean

Gets or sets whether to load child records on demand in remote data binding. When loadChildOnDemand set to true, child records are loaded only when expanded, and parent records are rendered in a collapsed state initially.

loadingIndicator

LoadingIndicatorModel

Configures the loading indicator for the Gantt Chart. Specifies the type of indicator to display (spinner or shimmer effect) during waiting periods when actions are performed in the Gantt Chart.

locale

string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

milestoneTemplate

string | Function

Defines a custom template for rendering milestone tasks in the Gantt chart. This template allows you to customize the appearance of milestone tasks.

parentTaskbarTemplate

string | Function

Defines a custom template for rendering parent task bars in the Gantt chart. This template allows you to customize the appearance of parent task bars.

    <template>
        <ejs-gantt :parentTaskbarTemplate="'parentTaskbarTemplate'">
             <template v-slot:parentTaskbarTemplate="{data}">
        <div class="e-gantt-parent-taskbar-inner-div e-gantt-parent-taskbar" style="height:100%">
                <div class="e-gantt-parent-progressbar-inner-div e-gantt-parent-progressbar" 
                       style="width:${ganttProperties.progressWidth}px;height:100%">
                  <span class="e-task-label"
                       style="position:absolute;top:5px;font-size:12px;text-overflow:ellipsis;height:90%;overflow:hidden;">{{data.TaskName}}
                  </span>
                 </div>
               </div>
            </template>
        </ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                labelSettings: {
                    leftLabel: 'Task ID: ${taskData.TaskID}',
                    rightLabel:'Progress Value: ${taskData.Progress}',
                    taskLabel: '${Progress}%'
                },
            },
        }
        provide: { }
    }});
</script>

projectEndDate

Date | string

Defines the end date of the project. If the projectEndDate is not set, it will be automatically calculated based on the data source. The date can be provided as a Date object or a string in a valid date format.

projectStartDate

Date | string

Defines the start date of the project. If the projectStartDate is not set, it will be automatically calculated based on the data source. The date can be provided as a Date object or a string in a valid date format.

query

Query

Defines an external Query that will be executed in conjunction with data processing to filter, sort the data. This allows for advanced data manipulation before binding the data to the Gantt chart.

readOnly

boolean

If readOnly is set to true, the Gantt chart becomes read-only, meaning tasks and other elements cannot be edited. This setting disables all editing features, including task updates, dependency management, and any editing acions.

renderBaseline

boolean

If renderBaseline is set to true, baselines will be rendered for tasks in the Gantt chart. Baselines provide a visual reference to track the planned vs. actual progress of tasks.

resourceFields

ResourceFieldsModel

Defines the mapping properties to extract resource values, such as id, name, unit, and group from the resource collection in the Gantt chart. This helps to map data from a custom resource collection to the appropriate fields for resource allocation.

resourceIDMapping

string

Defines the mapping property to retrieve the resource ID value from the resource collection. This is used to map the resource ID from the resource data to the Gantt chart for resource allocation.

resourceNameMapping

string

Defines the mapping property to retrieve the resource name value from the resource collection. This is used to map the resource name from the resource data to the Gantt chart for task allocation.

resources

object[]

Defines the collection of resources assigned to the project.

rowHeight

number

Defines the height of grid and chart rows in the Gantt chart. This property sets the vertical space allocated for each task or row, allowing customization of row sizes.

searchSettings

SearchSettingsModel

Configures the search functionality within the Gantt chart.

    <template>
        <ejs-gantt :searchSettings="searchSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, Filter  } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                searchSettings: { fields: ['TaskName'], operator: 'contains', key: 'List', ignoreCase: true, hierarchyMode: 'Parent'}
            },
        }
        provide: { gantt: [ Filter ] }
    }});
</script>

segmentData

object[]

Defines the collection of segments assigned to tasks in the Gantt chart.

selectedRowIndex

number

The selectedRowIndex allows you to specify the index of the row to be selected at the time of initial rendering. It can also be used to get the currently selected row index after selection. A value of -1 indicates no row is selected.

selectionSettings

SelectionSettingsModel

Configures the settings for selection in the Gantt chart.

    <template>
        <ejs-gantt :selectionSettings="selectionSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, Selection } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                selectionSettings: {
                    mode: 'Row',
                    type: 'Multiple'
                }
            },
        }
        provide: { gantt: [ Selection ] }
    }});
</script>

showColumnMenu

boolean

If showColumnMenu set to true, enables the column menu options for each column in the Gantt chart.

showInlineNotes

boolean

To show notes column cell values inside the cell or in tooltip.

showOverAllocation

boolean

If showOverAllocation set to true, enables the rendering of the overallocation container in the Gantt chart.

sortSettings

SortSettingsModel

Configures the sort settings for the Gantt chart.

    <template>
        <ejs-gantt :sortSettings="sortSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin, Sort } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                sortSettings: { columns: [{ field: 'TaskID', direction: 'Descending' }], allowUnsort: true },
            },
        }
        provide: { gantt: [ Sort ] }
    }});
</script>

splitterSettings

SplitterSettingsModel

Configures the splitter settings for the Gantt chart.

    <template>
        <ejs-gantt :splitterSettings="splitterSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                splitterSettings:{
                    position: "50%",
                    minimum: "200",
                    separatorSize: 5,
                    view: 'Default'
                },
            },
        }
        provide: { }
    }});
</script>

taskFields

TaskFieldsModel

Defines the mapping properties to extract task-related values, such as ID, start date, end date, duration, and progress, from the data source. This allows the Gantt chart to properly map the provided data to the corresponding task fields and render them accordingly.

    <template>
        <ejs-gantt :taskFields = "taskFields"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                taskFields: {
                    id: 'TaskID',
                    name: 'TaskName',
                    startDate: 'StartDate',
                    duration: 'Duration',
                    dependency: 'Predecessor',
                    progress: 'Progress',
                    baselineStartDate: 'BaselineStartDate',
                    baselineEndDate: 'BaselineEndDate',
                    durationUnit: 'DurationUnit',
                    expandState: 'isExpand',
                    indicators: 'Indicators',
                    milestone: 'Milestone',
                    notes: 'info',
                    resourceInfo: 'resourceInfo',
                    child: 'subtasks',
                },
            },
        }
        provide: { }
    }});
</script>

taskMode

ScheduleMode

Specifies task schedule mode for a project.

taskType

TaskType

taskType Specifies the task type for task whether fixedUnit or fixedWork or fixedDuration.

  • fixedUnit: Sets the task type as fixedUnit.
  • fixedWork: Sets the task type as fixedWork.
  • fixedDuration: Sets the task type as fixedDuration.

taskbarHeight

number

Defines height of the taskbar element in the Gantt chart.

taskbarTemplate

string | Function

The task bar template that renders customized child task bars from the given template. This property allows users to define a custom template for rendering child task bars in the Gantt chart.

    <template>
      <ejs-gantt :taskbarTemplate="'taskbarTemplate'">
      <template v-slot:taskbarTemplate="{data}">
        <div class="e-gantt-child-taskbar-inner-div e-gantt-child-taskbar" style="height:100%">
         <div class="e-gantt-child-progressbar-inner-div e-gantt-child-progressbar" 
          style="width:${ganttProperties.progressWidth}px;height:100%">
           <span class="e-task-label"
                  style="position:absolute;top:5px;font-size:12px;text-overflow:ellipsis;height:90%;overflow:hidden;">{{data.TaskName}}
           </span>
         </div>
        </div>
      </template>
        </ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
 
            },
        }
        provide: { }
    }});
</script>

timelineSettings

TimelineSettingsModel

Configures timeline settings of Gantt. Defines default timeline modes or customized top tier mode and bottom tier mode or single tier only.

    <template>
        <ejs-gantt :timelineSettings="timelineSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                timelineSettings: {
                    showTooltip: true,
                    timelineUnitSize: 80,
                    timelineViewMode: 'Week',
                    updateTimescaleView: true,
                    weekStartDay: 0,
                    weekendBackground: 'red',
                    topTier: {
                        format: 'MMM dd, yyyy',
                        unit: 'Week',
                    },
                    bottomTier: {
                        unit: 'Day',
                        format: 'EEE, dd',
                        count: 1,
                    }
                },
            },
        }
        provide: { }
    }});
</script>

timelineTemplate

string | Function

Renders customized html elements for timeline cell from the given template.

timezone

string

By default, task schedule dates are calculated with system time zone. If the Gantt chart is assigned with a specific time zone, then schedule dates are calculated based on the given time zone date value.

toolbar

[]

toolbar defines the toolbar items of the Gantt. It contains built-in and custom toolbar items. If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the Gantt’s toolbar.

The available built-in toolbar items are:

  • Add: Adds a new record.
  • Edit: Edits the selected task.
  • Update: Updates the edited task.
  • Delete: Deletes the selected task.
  • Cancel: Cancels the edit state.
  • Search: Searches tasks by the given key.
  • ExpandAll: Expands all the task of Gantt.
  • CollapseAll: Collapses all the task of Gantt.
  • PrevTimeSpan: Extends timeline with one unit before the timeline start date.
  • NextTimeSpan: Extends timeline with one unit after the timeline finish date.
  • ZoomIn: ZoomIn the Gantt control.
  • ZoomOut: ZoomOut the Gantt control.
  • ZoomToFit: Display the all tasks within the viewable Gantt chart.
  • ExcelExport: To export in Excel format.
  • CsvExport : To export in CSV format.
  • Indent: To indent a task to one level.
  • Outdent: To outdent a task from one level.

tooltipSettings

TooltipSettingsModel

Enables or disables default tooltip of Gantt element and defines customized tooltip for Gantt elements.

    <template>
        <ejs-gantt :tooltipSettings="tooltipSettings"></ejs-gantt>
    <template>
    <style>
    </style>
    <script>
    import Vue from "vue";
    import { GanttPlugin } from "@syncfusion/ej2-vue-gantt";
    Vue.use(GanttPlugin);

    export default Vue.extend({
        data: function(){
            return{
                tooltipSettings:{
                    showTooltip: true,
                    taskbar: '<div>TaskID: ${TaskID}</div>',
                    connectorLine: '<div>Offset : ${offsetString}</div>',
                    editing: '<div>Duration : ${duration}</div>',
                    baseline: '<div>Baseline StartDate : ${this.getFormatedDate(BaselineStartDate)}</div>'
                }
            },
        }
        provide: { }
    }});
</script>

treeColumnIndex

number

To define expander column index in Grid.

undoRedoActions

GanttAction[]

undoRedoActions Defines action items that retain for undo and redo operation.

undoRedoStepsCount

number

Defines number of undo/redo actions that should be stored.

updateOffsetOnTaskbarEdit

boolean

Specifies whether to update offset value on a task for all the predecessor edit actions.

validateManualTasksOnLinking

boolean

If validateManualTasksOnLinking is set to true, it enables date validation while connecting manually scheduled tasks with predecessor.

viewType

ViewType

Defines the view type of the Gantt.

weekWorkingTime

WeekWorkingTimeModel[]

Specifies unique working hours for each weekday in gantt chart to tailor schedules precisely.

width

number | string

Defines the width of the Gantt component container.

workUnit

WorkUnit

workUnit Specifies the work unit for each tasks whether day or hour or minute.

  • day: Sets the work unit as day.
  • hour: Sets the work unit as hour.
  • minute: Sets the work unit as minute.

workWeek

string[]

Defines workweek of project.

zoomingLevels

ZoomTimelineSettings[]

Configure zooming levels of Gantt Timeline.

Contents
Contents

GanttModel

23 Sep 202524 minutes to read

Interface for a class Gantt

Properties

actionBegin EmitType<Object|PageEventArgs|FilterEventArgs|SortEventArgs|ITimeSpanEventArgs|IDependencyEventArgs|ITaskAddedEventArgs|ZoomEventArgs>

Triggers when Gantt actions such as sorting, filtering, searching etc., starts.

actionComplete EmitType<FilterEventArgs|SortEventArgs|ITaskAddedEventArgs|IKeyPressedEventArgs|ZoomEventArgs>

Triggers when Gantt actions such as sorting, filtering, searching etc. are completed.

actionFailure EmitType<FailureEventArgs>

Triggers when actions are failed.

beforeDataBound EmitType<Object>

Triggers before the data is bound to the TreeGrid in the Gantt component.
This event is triggered before any visual elements (taskbars, rows, timelines) are rendered in the DOM.

beforeExcelExport EmitType<Object>

Triggers before Gantt data is exported to Excel file.

beforePdfExport EmitType<Object>

Triggers before Gantt data is exported to PDF document.

beforeTooltipRender EmitType<BeforeTooltipRenderEventArgs>

Triggers before tooltip get rendered.

cellDeselected EmitType<CellDeselectEventArgs>

Triggers when a particular selected cell is deselected.

cellDeselecting EmitType<CellDeselectEventArgs>

Triggers before the selected cell is deselecting.

cellEdit EmitType<CellEditArgs>

This will be triggered a cell get begins to edit.

cellSave EmitType<CellSaveArgs>

Triggers before a cell’s value is saved in the Gantt chart.
This event allows cancellation of the save action.

cellSelected EmitType<CellSelectEventArgs>

Triggers after a cell is selected.

cellSelecting EmitType<CellSelectingEventArgs>

Triggers before any cell selection occurs.

collapsed EmitType<ICollapsingEventArgs>

This will be triggered after the row getting collapsed.

collapsing EmitType<ICollapsingEventArgs>

This will be triggered before the row getting collapsed.

columnDrag EmitType<ColumnDragEventArgs>

Triggers when column header element is dragged (moved) continuously.

columnDragStart EmitType<ColumnDragEventArgs>

Triggers when column header element drag (move) starts.

columnDrop EmitType<ColumnDragEventArgs>

Triggers when a column header element is dropped on the target column.

columnMenuClick EmitType<ColumnMenuClickEventArgs>

Triggers when click on column menu.

columnMenuOpen EmitType<ColumnMenuOpenEventArgs>

Triggers before column menu opens.

contextMenuClick EmitType<CMenuClickEventArgs>

Triggers when click on context menu.

contextMenuOpen EmitType<CMenuOpenEventArgs>

Triggers before context menu opens.

created EmitType<Object>

Triggers when the component is created.

dataBound EmitType<Object>

Triggers when data source is populated in the Grid.

dataStateChange EmitType<DataStateChangeEventArgs>

Triggers when the Gantt actions such as Sorting, Editing etc., are done.
In this event,the current view data and total record count should be assigned to the dataSource based on the action performed.

destroyed EmitType<Object>

Triggers when the component is destroyed.

endEdit EmitType<ITaskbarEditedEventArgs>

This will be triggered when a task get saved by cell edit.

excelExportComplete EmitType<ExcelExportCompleteArgs>

Triggers after Gantt data is exported to Excel file.

excelHeaderQueryCellInfo EmitType<ExcelHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to Excel file.
You can also customize the Excel cells.

excelQueryCellInfo EmitType<ExcelQueryCellInfoEventArgs>

Triggers before exporting each cell to Excel file.
You can also customize the Excel cells.

expanded EmitType<ICollapsingEventArgs>

This will be triggered after the row getting expanded.

expanding EmitType<ICollapsingEventArgs>

This will be triggered before the row getting expanded.

headerCellInfo EmitType<HeaderCellInfoEventArgs>

This will be triggered before the header cell element is appended to the Grid element.

load EmitType<Object>

Triggered before the Gantt control gets rendered.

onMouseMove EmitType<IMouseMoveEventArgs>

This event will be triggered when mouse move on Gantt.

onTaskbarClick EmitType<ITaskbarClickEventArgs>

This event will be triggered when click on taskbar element.

pdfColumnHeaderQueryCellInfo EmitType<PdfColumnHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to PDF document. You can also customize the PDF cells.

pdfExportComplete EmitType<Object>

Triggers after TreeGrid data is exported to PDF document.

pdfQueryCellInfo EmitType<PdfQueryCellInfoEventArgs>

Triggers before exporting each cell to PDF document. You can also customize the PDF cells.

pdfQueryTaskbarInfo EmitType<Object>

Triggers before exporting each taskbar to PDF document. You can also customize the taskbar.

pdfQueryTimelineCellInfo EmitType<PdfQueryTimelineCellInfoEventArgs>

Triggers before exporting each cell to PDF document. You can also customize the PDF cells.

queryCellInfo EmitType<QueryCellInfoEventArgs>

This will be triggered before the header cell element is appended to the Grid element.

queryTaskbarInfo EmitType<IQueryTaskbarInfoEventArgs>

This will be triggered after the taskbar element is appended to the Gantt element.

recordDoubleClick EmitType<RecordDoubleClickEventArgs>

This event will be triggered when double click on record.

resizeStart EmitType<ResizeArgs>

Triggers when column resize starts.

resizeStop EmitType<ResizeArgs>

Triggers when column resize ends.

resizing EmitType<ResizeArgs>

Triggers on column resizing.

rowDataBound EmitType<RowDataBoundEventArgs>

This will be triggered before the row element is appended to the Grid element.

rowDeselected EmitType<RowDeselectEventArgs>

Triggers when a selected row is deselected.

rowDeselecting EmitType<RowDeselectEventArgs>

Triggers before deselecting the selected row.

rowDrag EmitType<RowDragEventArgs>

Triggers when row elements are dragged (moved) continuously.

rowDragStart EmitType<RowDragEventArgs>

Triggers when row element’s drag(move) starts.

rowDragStartHelper EmitType<RowDragEventArgs>

Triggers when row element’s before drag(move).

rowDrop EmitType<RowDragEventArgs>

Triggers when row elements are dropped on the target row.

rowSelected EmitType<RowSelectEventArgs>

Triggers after row selection occurs.

rowSelecting EmitType<RowSelectingEventArgs>

Triggers before row selection occurs.

splitterResizeStart EmitType<ResizeEventArgs>

Triggers when splitter resizing starts.

splitterResized EmitType<ISplitterResizedEventArgs>

Triggers when splitter resizing action completed.

splitterResizing EmitType<ResizingEventArgs>

Triggers when splitter bar was dragging.

taskbarEdited EmitType<ITaskbarEditedEventArgs>

Triggered when a taskbar is dragged and dropped into a new position on the Gantt chart.

taskbarEditing EmitType<ITaskbarEditedEventArgs>

Triggered when a taskbar is in the dragging state on the Gantt chart.

toolbarClick EmitType<ClickEventArgs>

Triggers when toolbar item was clicked.

UpdateOffsetOnTaskbarEdit boolean

Specifies whether to update offset value on a task for all the predecessor edit actions.

addDialogFields AddDialogFieldSettingsModel[]

Defines the tabs and fields to be displayed in the add dialog.
If not specified, the fields will be derived from the taskSettings and columns values.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, AddDialogFieldsDirective, AddDialogFieldDirective } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
    }
    render() {
        return <GanttComponent>
        <AddDialogFieldsDirective>
            <AddDialogFieldDirective type='General' headerText='General' fields={['TaskID', 'TaskName']}></AddDialogFieldDirective>
            <AddDialogFieldDirective type='Dependency'></AddDialogFieldDirective>
            <AddDialogFieldDirective type='Resources'></AddDialogFieldDirective>
            <AddDialogFieldDirective type='Notes'></AddDialogFieldDirective>
        </AddDialogFieldsDirective>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

allowExcelExport boolean

If allowExcelExport set to true, then it will allow the user to export Gantt chart to Excel and CSV file.

allowFiltering boolean

Enables or disables filtering functionality in the Gantt chart.

allowKeyboard boolean

Enables or disables keyboard interactions in the Gantt chart.

allowParentDependency boolean

Specifies whether to allow dependency connection support for parent records.

allowPdfExport boolean

If allowPdfExport set to true, then it will allow the user to export Gantt chart to PDF file.

allowReordering boolean

If allowReordering is set to true, Gantt chart columns can be reordered.
Reordering can be done by drag and drop of a particular column from one index to another index.

allowResizing boolean

Enables column resizing in the Gantt chart when allowResizing is set to true.
When enabled, users can adjust the width of columns by dragging the column borders.

allowRowDragAndDrop boolean

If allowRowDragAndDrop set to true, then it will allow the user to perform row drag and drop action in Gantt chart.

allowSelection boolean

If allowSelection is set to true, it enables row selection in the Gantt chart, and the selected rows are highlighted.

allowSorting boolean

If allowSorting is set to true, it enables sorting of Gantt chart tasks when the column header is clicked.

allowTaskbarDragAndDrop boolean

Defines whether to enable or disable the taskbar drag and drop action in the Gantt chart.

allowTaskbarOverlap boolean

Specifies whether taskbars can overlap in the Gantt chart.

allowUnscheduledTasks boolean

Enables or disables the rendering of unscheduled tasks in the Gantt chart.
When allowUnscheduledTasks set to true, unscheduled tasks will be displayed in the chart.

autoCalculateDateScheduling boolean

Specifies whether to auto calculate the start and end dates based on factors such as working time, holidays, weekends, and task dependencies.

autoFocusTasks boolean

Enables or disables automatic focusing on the taskbar when a task is clicked.

baselineColor string

Specifies the color of the baseline bar in the Gantt chart.

collapseAllParentTasks boolean

Defines whether all root tasks should be rendered in a collapsed state. When collapseAllParentTasks set to true, all parent tasks will be collapsed by default.

columnMenuItems []

columnMenuItems defines both built-in and custom menu items for the Gantt chart column menu.



The available built-in items are,

  • ColumnChooser - To show/hide the TreeGrid columns.
  • SortAscending - Sort the current column in ascending order.
  • SortDescending - Sort the current column in descending order.
  • AutoFitAll - Auto fit the size of all columns.
  • AutoFit - Auto fit the size of the current column.
  • Filter - Displays filter options based on the filterSettings property.

columns Column[]|string[]|ColumnModel[]

Defines the collection of columns displayed in the Gantt chart grid.
If the columns declaration is empty, the columns are automatically populated based on the taskSettings values.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
    }
    render() {
        return <GanttComponent>
            <ColumnsDirective>
                <ColumnDirective field='TaskID' width='150' headerText='Task ID' headerTextAlign='Left' allowFiltering= 'false'></ColumnDirective>
                <ColumnDirective field='TaskName' clipMode='EllipsisWithTooltip' allowEditing='true' hideAtMedia='(min-width: 700px)'></ColumnDirective>
                <ColumnDirective field='Duration' edittype='stringedit' allowReordering='true' maxWidth= '400'></ColumnDirective>
                <ColumnDirective field='Progress' textAlign='Right' allowResizing='false' visible='true' format='C'></ColumnDirective>
                <ColumnDirective field='StartDate' width='250' allowSorting='false' minWidth='200'><ColumnDirective>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

connectorLineBackground string

Defines the background color of the dependency lines (connector lines) in the Gantt chart.
You can set the color as a valid CSS color string (e.g., “red”, “#FF5733”, “rgb(255,0,0)”).

connectorLineWidth number

Defines the width of the dependency lines in the Gantt chart.
The value should be a positive integer, representing the thickness of the lines.

contextMenuItems ContextMenuItem[]|ContextMenuItemModel[]

Defines the built-in and custom items that appear in the context menu of the Gantt chart.
You can use this property to control the content and functionality of the right-click context menu.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, ContextMenu } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.contextMenuItems = ['AutoFitAll', 'AutoFit', 'TaskInformation', 'DeleteTask', 'Save', 'Cancel', 'SortAscending', 'SortDescending', 'Add', 'DeleteDependency', 'Convert',
            { text: 'Collapse the Row', target: '.e-content', id: 'collapserow' },
            { text: 'Expand the Row', target: '.e-content', id: 'expandrow' },
        ];
    }
    render() {
        return <GanttComponent contextMenuItems={this.contextMenuItems}>
        <Inject services={[ContextMenu]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

dataSource Object[]|DataManager|Object

Defines the data source for the Gantt chart, which is used to render rows and tasks.
The dataSource can be an array of JavaScript objects, an instance of DataManager, or a single object.
The array of objects should contain the task data with properties such as TaskID, TaskName, StartDate, EndDate, etc.
This allows dynamic binding of tasks and their relationships (e.g., dependencies, subtasks, progress) to the Gantt chart.

// Hierarchical data binding.
let dataSource = [
    {
        TaskID: 1,
        TaskName: 'Project Initiation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 }
        ]
    },
];
// Self-referential data binding (Flat data).
let dataSource = [
    { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
    { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50, ParentId: 1 },
    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50, ParentId: 1 }
];
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        // Remote data
         this.dataSource = new DataManager({
            url: 'https://ej2services.syncfusion.com/production/web-services/api/GanttData',
            adaptor: new WebApiAdaptor,
            crossDomain: true
        });
    }
    render() {
        return <GanttComponent dataSource={this.dataSource}>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

dateFormat string

Specifies the date format for displaying dates in the Gantt chart, including in tooltips and grid cells.
By default, the format is determined based on the current culture/locale settings.

dayWorkingTime DayWorkingTimeModel[]

Defines the customized working time for the project.
This helps in accurately planning tasks based on available working hours and ensures proper task scheduling.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        public dayWorkingTime: any = [{ from: 9, to: 18 }];
    }
    render() {
        return <GanttComponent dayWorkingTime={this.dayWorkingTime}>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

disableHtmlEncode boolean

If disableHtmlEncode is set to true, the Gantt component disables HTML entity encoding across the Gantt content, allowing custom HTML elements to be rendered.

durationUnit DurationUnit

durationUnit Specifies the duration unit for each task. The available options are:

  • day: Sets the duration unit to day.
  • hour: Sets the duration unit to hour.
  • minute: Sets the duration unit to minute.

editDialogFields EditDialogFieldSettingsModel[]

Defines the tabs and fields to be displayed in the edit dialog.
If not specified, the fields will be derived from the taskSettings and columns values.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, EditDialogFieldsDirective, EditDialogFieldDirective } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
    }
    render() {
        return <GanttComponent>
        <EditDialogFieldsDirective>
            <EditDialogFieldDirective type='General' headerText='General' fields={['TaskID', 'TaskName']}></EditDialogFieldDirective>
            <EditDialogFieldDirective type='Dependency'></EditDialogFieldDirective>
            <EditDialogFieldDirective type='Resources'></EditDialogFieldDirective>
            <EditDialogFieldDirective type='Notes'></EditDialogFieldDirective>
        </EditDialogFieldsDirective>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

editSettings EditSettingsModel

Configures the edit settings for the Gantt chart, such as enabling or disabling task modifications.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Edit } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.editSettings = {
            allowAdding: true,
            allowEditing: true,
            allowDeleting: true,
            allowTaskbarEditing: true,
            mode:'Auto',
            newRowPosition: 'Top',
            showDeleteConfirmDialog: true
        };
    }
    render() {
        return <GanttComponent editSettings={this.editSettings}>
        <Inject services={[Edit]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

enableAdaptiveUI boolean

If enableAdaptiveUI is set to true, the pop-up UI becomes adaptive to smaller screens, enabling better usability for filtering and other features.

enableAutoWbsUpdate boolean

Enables the automatic update of WBS codes when performing actions like sorting, filtering, row drag and drop, and other grid operations that change the task order or hierarchy.
When set to true, the Gantt component will refresh and regenerate the WBS codes dynamically after such actions to ensure the codes remain in sync with the current task structure.

enableContextMenu boolean

If enableContextMenu is set to true, enables the context menu in the Gantt chart.
The context menu provides additional actions that can be accessed by right-clicking on Gantt chart elements

enableCriticalPath boolean

Enables the highlighting of critical tasks in the Gantt Chart that directly affect the project’s end date.
When enabled, tasks that are critical to the project timeline will be visually distinguished by colours.

enableHover boolean

If enableHover is set to true, it enables hover in the Gantt chart and highlights the rows, chart rows, header cells and timeline cells.

enableHtmlSanitizer boolean

Specifies whether to display or remove the untrusted HTML values in the TreeGrid component.
If enableHtmlSanitizer set to true, any potentially harmful strings and scripts are sanitized before rendering.

enableImmutableMode boolean

If enableImmutableMode is set to true, the Gantt Chart will reuse existing rows from previous results instead of
performing a full refresh when Gantt actions are executed.

enableMultiTaskbar boolean

Enables the rendering of child taskbars on the parent row when it is in a collapsed state in the Gantt chart.

enablePersistence boolean

Enable or disable persisting component’s state between page reloads.

enablePredecessorValidation boolean

If enablePredecessorValidation is set to true, enables validation for predecessor links in the Gantt chart.

enableRtl boolean

Enable or disable rendering component in right to left direction.

enableTimelineVirtualization boolean

Enables better performance for projects with a large time span by initially rendering only the visible timeline cells.
Subsequent cells are loaded on horizontal scrolling.

enableUndoRedo boolean

Enables or disables the undo and redo functionality in the Gantt chart.

enableVirtualMaskRow boolean

Specifies whether to display shimmer effect during scrolling action in virtual scrolling feature. If disabled, spinner is shown instead of shimmer effect.

enableVirtualization boolean

If enableVirtualization is set to true, the Gantt chart will render only the rows visible within the viewport.
and load subsequent rows as the user scrolls vertically. This improves performance when dealing with large datasets.

enableWBS boolean

Enables Work Breakdown Structure (WBS) functionality in the Gantt Chart.
When set to true, the Gantt Chart automatically generates WBS codes based on the task hierarchy.
A dedicated WBS Code column will be shown to represent the task structure.
Additionally, if task dependencies (predecessors) are mapped in the data source, a WBS Predecessor column will also be displayed to reflect dependency information using WBS codes.

eventMarkers EventMarkerModel[]

Defines the events and milestones along the project timeline.
These event markers indicate significant events or milestones throughout the project’s duration.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, DayMarkers, EventMarkersDirective, EventMarkerDirective  } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.eventMarkerDay = new Date('4/10/2019');
    }
    render() {
        return <GanttComponent>
        <EventMarkersDirective>
            <EventMarkerDirective day={this.eventMarkerDay} cssClass='e-custom-event-marker' label='Project approval and kick-off'></EventMarkerDirective>
        </EventMarkersDirective>
        <Inject services={[DayMarkers]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

filterSettings FilterSettingsModel

Configures the filter settings for the Gantt chart, enabling users to filter tasks based on specific columns or criteria.
The filterSettings property allows customization of filter behavior, such as which columns to filter and the filter type.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Filter } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.FilterSettings = {
            columns: [
                { field: 'TaskName', matchCase: false, operator: 'startswith', predicate: 'and', value: 'Identify' },
                { field: 'TaskID', matchCase: false, operator: 'equal', predicate: 'and', value: 2 }
            ],
            ignoreAccent: true
        };
    }
    render() {
        return <GanttComponent filterSettings={this.FilterSettings}>
        <Inject services={[Filter]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

gridLines GridLine

Configures the grid lines displayed in the TreeGrid and Gantt chart.
The gridLines property allows customization of the type of grid lines to be shown, either horizontal, vertical, or both.

height number|string

Defines the height of the Gantt component container.
The height property can be set to a specific value (in pixels or percentage) or set to ‘auto’ for automatic height adjustment based on content.

highlightWeekends boolean

If highlightWeekends is set to true, it highlights all weekend days in the week-day timeline mode.
This makes weekends visually distinct in the timeline view.

holidays HolidayModel[]

Defines holidays within the project timeline, allowing you to mark specific dates as holidays.
This helps in accounting for non-working days in scheduling and task planning.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, DayMarkers, HolidaysDirective, HolidayDirective } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
    }
    render() {
        return <GanttComponent>
        <HolidaysDirective>
            <HolidayDirective from='04/10/2019' label='Local Holiday' cssClass='e-custom-holiday'><HolidayDirective>
        </HolidaysDirective>
        <Inject services={[DayMarkers]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

includeWeekend boolean

Defines whether weekend days should be considered as working days in the Gantt chart.
When includeWeekend set to true, weekends (Saturday and Sunday) are treated as regular working days.

labelSettings LabelSettingsModel

Configures the labels displayed on the right, left, and inside the taskbars in the Gantt chart.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.labelSettings = {
            leftLabel: 'TaskID',
            rightLabel: 'Task Name: ${taskData.TaskName}',
            taskLabel: '${Progress}%'
        };
    }
    render() {
        return <GanttComponent labelSettings={this.labelSettings}>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

loadChildOnDemand boolean

Gets or sets whether to load child records on demand in remote data binding. When loadChildOnDemand set to true, child records are loaded only when expanded, and parent records are rendered in a collapsed state initially.

loadingIndicator LoadingIndicatorModel

Configures the loading indicator for the Gantt Chart. Specifies the type of indicator to display (spinner or shimmer effect) during waiting periods when actions are performed in the Gantt Chart.

locale string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

milestoneTemplate string|Function

Defines a custom template for rendering milestone tasks in the Gantt chart. This template allows you to customize the appearance of milestone tasks.

parentTaskbarTemplate string|Function

Defines a custom template for rendering parent task bars in the Gantt chart. This template allows you to customize the appearance of parent task bars.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Filter,IGanttData } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
     ParentTaskbarTemplate(props:IGanttData) {
    return (
      <div
        className="e-gantt-parent-taskbar-inner-div e-gantt-parent-taskbar"
        style={{ height: '100%' }}
      >
        <div
          className="e-gantt-parent-progressbar-inner-div e-row-expand e-gantt-parent-progressbar"
          style={{
            width: props.ganttProperties.progressWidth + 'px',
            height: '100%'
          }}
        ></div>
        <span
          className="e-task-label"
          style={{
            position: 'absolute',
            fontSize: '12px',
            color: 'white',
            top: '5px',
            left: '10px',
            fontFamily: 'Segoe UI',
            cursor: 'move',
          }}
        >
          {props.TaskName}
        </span>
      </div>
    );
  }
    }
    render() {
        return <GanttComponent parentTaskbarTemplate={ParentTaskbarTemplate} >
        <Inject services={[Filter]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

projectEndDate Date|string

Defines the end date of the project. If the projectEndDate is not set, it will be automatically calculated based on the data source.
The date can be provided as a Date object or a string in a valid date format.

projectStartDate Date|string

Defines the start date of the project. If the projectStartDate is not set, it will be automatically calculated based on the data source.
The date can be provided as a Date object or a string in a valid date format.

query Query

Defines an external Query
that will be executed in conjunction with data processing to filter, sort the data.
This allows for advanced data manipulation before binding the data to the Gantt chart.

readOnly boolean

If readOnly is set to true, the Gantt chart becomes read-only, meaning tasks and other elements cannot be edited.
This setting disables all editing features, including task updates, dependency management, and any editing acions.

renderBaseline boolean

If renderBaseline is set to true, baselines will be rendered for tasks in the Gantt chart.
Baselines provide a visual reference to track the planned vs. actual progress of tasks.

resourceFields ResourceFieldsModel

Defines the mapping properties to extract resource values, such as id, name, unit, and group from the resource collection in the Gantt chart.
This helps to map data from a custom resource collection to the appropriate fields for resource allocation.

resourceIDMapping string

Defines the mapping property to retrieve the resource ID value from the resource collection.
This is used to map the resource ID from the resource data to the Gantt chart for resource allocation.

resourceNameMapping string

Defines the mapping property to retrieve the resource name value from the resource collection.
This is used to map the resource name from the resource data to the Gantt chart for task allocation.

resources object[]

Defines the collection of resources assigned to the project.

rowHeight number

Defines the height of grid and chart rows in the Gantt chart.
This property sets the vertical space allocated for each task or row, allowing customization of row sizes.

searchSettings SearchSettingsModel

Configures the search functionality within the Gantt chart.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Filter } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.searchSettings = {
            fields: ['TaskName'], operator: 'contains', key: 'Soil', ignoreCase: true, hierarchyMode: 'Parent'
        };
    }
    render() {
        return <GanttComponent searchSettings={this.searchSettings}>
        <Inject services={[Filter]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

segmentData object[]

Defines the collection of segments assigned to tasks in the Gantt chart.

selectedRowIndex number

The selectedRowIndex allows you to specify the index of the row to be selected at the time of initial rendering.
It can also be used to get the currently selected row index after selection.
A value of -1 indicates no row is selected.

selectionSettings SelectionSettingsModel

Configures the settings for selection in the Gantt chart.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Selection  } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.selectionSettings = {
            mode: 'Row',
            type: 'Multiple'
        };
    }
    render() {
        return <GanttComponent selectionSettings={this.selectionSettings}>
        <Inject services={[Selection]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

showColumnMenu boolean

If showColumnMenu set to true, enables the column menu options for each column in the Gantt chart.

showInlineNotes boolean

To show notes column cell values inside the cell or in tooltip.

showOverAllocation boolean

If showOverAllocation set to true, enables the rendering of the overallocation container in the Gantt chart.

sortSettings SortSettingsModel

Configures the sort settings for the Gantt chart.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Sort } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.sortSettings = { columns: [{ field: 'TaskID', direction: 'Descending' }], allowUnsort: true };
    }
    render() {
        return <GanttComponent sortSettings={this.sortSettings}>
        <Inject services={[Sort]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

splitterSettings SplitterSettingsModel

Configures the splitter settings for the Gantt chart.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.splitterSettings = {
            position: "50%",
            minimum: "200",
            separatorSize: 5,
            view: 'Default'
        };
    }
    render() {
        return <GanttComponent splitterSettings={this.splitterSettings}>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

taskFields TaskFieldsModel

Defines the mapping properties to extract task-related values, such as ID, start date, end date, duration, and progress, from the data source.
This allows the Gantt chart to properly map the provided data to the corresponding task fields and render them accordingly.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.taskFields = {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            dependency: 'Predecessor',
            progress: 'Progress',
            baselineStartDate: 'BaselineStartDate',
            baselineEndDate: 'BaselineEndDate',
            durationUnit: 'DurationUnit',
            expandState: 'isExpand',
            indicators: 'Indicators',
            milestone: 'Milestone',
            notes: 'info',
            resourceInfo: 'resourceInfo',
            child: 'subtasks',
        };
    }
    render() {
        return <GanttComponent taskFields={this.taskFields}>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

taskMode ScheduleMode

Specifies task schedule mode for a project.

taskType TaskType

taskType Specifies the task type for task whether fixedUnit or fixedWork or fixedDuration.

  • fixedUnit: Sets the task type as fixedUnit.
  • fixedWork: Sets the task type as fixedWork.
  • fixedDuration: Sets the task type as fixedDuration.

taskbarHeight number

Defines height of the taskbar element in the Gantt chart.

taskbarTemplate string|Function

The task bar template that renders customized child task bars from the given template.
This property allows users to define a custom template for rendering child task bars in the Gantt chart.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Filter,IGanttData } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
      TaskbarTemplate(props:IGanttData) {
      return (
      <div
        className="e-gantt-child-taskbar-inner-div e-gantt-child-taskbar"
        style={{ height: '100%' }}
      >
        <div
          className="e-gantt-child-progressbar-inner-div e-gantt-child-progressbar"
          style={{
            width: props.ganttProperties.progressWidth + 'px',
            height: '100%',
          }}
        ></div>
        <span
          className="e-task-label"
          style={{
            position: 'absolute',
            fontSize: '12px',
            color: 'white',
            top: '5px',
            left: '10px',
            fontFamily: 'Segoe UI',
            cursor: 'move',
          }}
        >
          {props.TaskName}
        </span>
      </div>
    );
  }
    }
    render() {
        return <GanttComponent taskbarTemplate={TaskbarTemplate}>
        <Inject services={[Filter]}/>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

timelineSettings TimelineSettingsModel

Configures timeline settings of Gantt.
Defines default timeline modes or customized top tier mode and bottom tier mode or single tier only.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
        this.timelineSettings = {
            showTooltip: true,
            timelineUnitSize: 80,
            timelineViewMode: 'Week',
            updateTimescaleView: true,
            weekStartDay: 0,
            weekendBackground: 'red',
            topTier: {
                format: 'MMM dd, yyyy',
                unit: 'Week',
            },
            bottomTier: {
                unit: 'Day',
                format: 'EEE, dd',
                count: 1,
            }
        };
    }
    render() {
        return <GanttComponent timelineSettings={this.timelineSettings}>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

timelineTemplate string|Function

Renders customized html elements for timeline cell from the given template.

timezone string

By default, task schedule dates are calculated with system time zone. If the Gantt chart is assigned with a specific time zone,
then schedule dates are calculated based on the given time zone date value.

toolbar []

toolbar defines the toolbar items of the Gantt.
It contains built-in and custom toolbar items.
If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the Gantt’s toolbar.



The available built-in toolbar items are:

  • Add: Adds a new record.
  • Edit: Edits the selected task.
  • Update: Updates the edited task.
  • Delete: Deletes the selected task.
  • Cancel: Cancels the edit state.
  • Search: Searches tasks by the given key.
  • ExpandAll: Expands all the task of Gantt.
  • CollapseAll: Collapses all the task of Gantt.
  • PrevTimeSpan: Extends timeline with one unit before the timeline start date.
  • NextTimeSpan: Extends timeline with one unit after the timeline finish date.
  • ZoomIn: ZoomIn the Gantt control.
  • ZoomOut: ZoomOut the Gantt control.
  • ZoomToFit: Display the all tasks within the viewable Gantt chart.
  • ExcelExport: To export in Excel format.
  • CsvExport : To export in CSV format.
  • Indent: To indent a task to one level.
  • Outdent: To outdent a task from one level.

tooltipSettings TooltipSettingsModel

Enables or disables default tooltip of Gantt element and defines customized tooltip for Gantt elements.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
class App extends React.Component {
    constructor() {
        super(...arguments);
         this.tooltipSettings = {
            showTooltip: true,
            taskbar: '<div>TaskID: ${TaskID}</div>',
            connectorLine: '<div>Offset : ${offsetString}</div>',
            editing: '<div>Duration : ${duration}</div>',
            baseline: '<div>Baseline StartDate : ${this.getFormatedDate(BaselineStartDate)}</div>'
        };
    }
    render() {
        return <GanttComponent tooltipSettings={this.tooltipSettings}>
        </GanttComponent>;
    }
};
ReactDOM.render(<App />, document.getElementById('root'));

treeColumnIndex number

To define expander column index in Grid.

undoRedoActions GanttAction[]

undoRedoActions Defines action items that retain for undo and redo operation.

undoRedoStepsCount number

Defines number of undo/redo actions that should be stored.

updateOffsetOnTaskbarEdit boolean

Specifies whether to update offset value on a task for all the predecessor edit actions.

validateManualTasksOnLinking boolean

If validateManualTasksOnLinking is set to true,
it enables date validation while connecting manually scheduled tasks with predecessor.

viewType ViewType

Defines the view type of the Gantt.

weekWorkingTime WeekWorkingTimeModel[]

Specifies unique working hours for each weekday in gantt chart to tailor schedules precisely.

width number|string

Defines the width of the Gantt component container.

workUnit WorkUnit

workUnit Specifies the work unit for each tasks whether day or hour or minute.

  • day: Sets the work unit as day.
  • hour: Sets the work unit as hour.
  • minute: Sets the work unit as minute.

workWeek string[]

Defines workweek of project.

zoomingLevels ZoomTimelineSettings[]

Configure zooming levels of Gantt Timeline.